<?php 
	
class Controller 
{
	public $file=NULL;
	public $data=array();
	public $listPerPage=NULL;
	public function __construct($file)
	{
		$this->setNewPerPage();
		$this->listPerPage();
		$this->file = $file;
		$this->load($this->control($file));
	}
	public function load($cfile)
	{	
		if(file_exists($cfile))
		require_once($cfile);
	}
	public function control($fileName)
	{
		return ROUTE."/".$fileName.".php";
	}
	public function model($fileName)
	{
		return ROUTE."/".$fileName."_model.php";
	}
	
	public function view($fileName)
	{
		return DIR_TEMPLATE.$fileName.".php";
	}
	
	public function set($key)
	{
		return $this->$data[$key];
	}
	public function setData()
	{
		foreach (array_keys($this->data) as $params)
		{
			${$params}=$this->data[$params];
		}
	}
	public function clear($text) 
	{
		$text = (trim($text));
		$search = array("#","/",'"',"'",'Ç','ç','Ğ','ğ','ı','İ','Ö','ö','Ş','ş','Ü','ü',' ', 'A','B','C',"D","E","F","G","H","I","J","K","L","M","N","O","P","R","S","T","V","U","Z","Y","W","X","Q");
		$replace = array("-","I","","",'c','c','g','g','i','i','o','o','s','s','u','u','-','a','b','c',"d","e","f","g","h","i","j","k","l","m","n","o","p","r","s","t","v","u","z","y","w","x","q");
		$new_text = str_replace($search,$replace,$text);
		return $new_text;
	}
	public function mainCheckButton()
	{
		$selectButton="<input type='checkbox' onclick='$(\"input[name*=selected]\").prop(\"checked\", this.checked)'>";
		return $selectButton;
	}
	public function formResults($messages)
	{
		return "<div class='resultParent'>
				<div class='formResult'>".$messages." <div class='close'></div></div>
				</div>
				";
	}
	public function getPageNum($total)
	{
		if(isset($_GET["p"])) $p=$_GET["p"];
		else $p=1;
		if($p>=$total) $p=$total;
		elseif($p<=0) $p=1;
		return $p;
	}
	public function getPagination($total,$link)
	{
		$stepby=6;
		$halfStep=3;
		$pages=array();
		$allPages=array();
		// getting active page;
		$p=$this->getPageNum($total);
		// setting listing page array $pages
		if($p>=$stepby and $stepby<=$total)
		{
			
			if($p+$halfStep<=$total)
			{	
				$x=$p-2;
				while($x<$p+3)
				{
					array_push($pages,$x);
					$x++;
				}
			}else 
			{	
				$x=$total-$stepby+2;
				while($x<=$total)
				{
					array_push($pages,$x);
					$x++;
				}
			}
			
		}elseif($p<$stepby and $stepby<=$total)
		{
			$x=0;
			while($x<$stepby)
			{
				$x++;
				array_push($pages,$x);
			}
		}elseif($p<$stepby and $stepby>$total)
		{
			$x=0;
			while($x<$total)
			{
				$x++;
				array_push($pages,$x);
			}
		}
		if($p<=1){ $pre=1; }else{$pre=$p-1;}
		if($p>=$total){$next=$total;}else{$next=$p+1;}
		$lastPage=$total;
		array_push($allPages,"<a href='".$link."&p=1' class='firstPage'>&laquo;</a>");
		array_push($allPages,"<a href='".$link."&p=".$pre."' class='previousPage'>&#8249;</a>");
		foreach($pages as $a)
		{
			if($a==$p)
			{
				$cl="class='focused_page'";
			}else 
			{
				$cl=NULL;
			}
			array_push($allPages,"<a href='".$link."&p=".$a."' ".$cl.">".$a."</a>");
		}
		array_push($allPages,"<a href='".$link."&p=".$next."' class='nextPage'>&#8250;</a>");
		array_push($allPages,"<a href='".$link."&p=".$lastPage."' class='lastPage'>&raquo;</a>");
		return $allPages;
	}
	public function getPrevPage()
	{
		$button="<a href='#' onClick='window.history.back()'>Geridön</a>";	
		return $button;
	}
	public function runFunction($class,$function)
	{
			$document=ROOT."plugins/".$class."/controller.php";
			if(file_exists($document))
			{
				require($document);
				$get=new $class("controller");
				if(method_exists($get,$function))
				{
					$get->$function();
				}else
				{
					echo "Böyle bir metod yok.";
				}
			}else
			{
				echo "Böyle bir sınıf yok";
			}
	}
	public function listPerPage()
	{
		if(isset($_SESSION["per_page"]))
		{
			$this->listPerPage=$_SESSION["per_page"];
		}else
		{
			$this->listPerPage=20;
		}
	}
	public function setNewPerPage()
	{
		if(isset($_POST["setNewPerPage"]))
		{
			$per=array(20,50,100,250,500,1000);
			$newPer=$_POST["setNewPerPage"];
			if(in_array($newPer,$per))
			{
				$new=$newPer;
			}else
			{
				$new=20;
			}
			$_SESSION["per_page"]=$new;
			$url=$_SERVER["REQUEST_URI"];
			header("location:".$url);
		}
	}
	public function perPageHtml()
	{
		$per=array(20,50,100,250,500,1000);
		$options=NULL;
		$perPage=$this->listPerPage;
		foreach($per as $page)
		{
			if($page==$perPage)
			{
				$sc="selected='selected'";
			}else
			{
				$sc=NULL;
			}
			$options.="<option value='".$page."' ".$sc.">".$page."</option>";
		}
		$form="<form action='' method='post'>
			   <label>Her sayfada</label>
			   <select name='setNewPerPage'>
			   ".$options."
			   </select>
			   <button>Kayıt göster</button>
			   </form>
			  ";
		return $form;
	}
	public function setHeader()
	{
		$model=new Model();
		$model->select_query("settings",NULL,NULL);
		$fetch=$model->results;
		foreach ($fetch as $a)
		{
			$this->data[$a["set_name"]]=$a["set_value"];
		}
	}
}

?>