<?php
class Model {
	public $db, $results, $row;
	public function __construct()
	{
		try 
		{
			$this->	db = new PDO(DB_TYPE.":host=".HOST.";dbname=".DB.";charset:".CHARSET, USER, PASS);
		} 
			catch ( PDOException $e ){
			print $e->getMessage();
		}	
	}
	
	public function select_query($table,$sql,$array)
	{
		$this->results=NULL;
		$qr=$this->db->prepare("select count(*) from ".PRE."$table {$sql}");
		$qr->execute($array);
		$tot=$qr->fetchColumn()/1;
		if($tot>0)
		{
			$this->fetch_query($table,$sql,$array);
		}else 
		{
			return NULL;
		}
	}
	public function fetch_query($table,$sql,$array)
	{
		$this->results=NULL;
		$qr=$this->db->prepare("select * from ".PRE."$table ".$sql);
		$qr->execute($array);
		$this->results = $qr->fetchAll(PDO::FETCH_ASSOC);
	}
	public function select_bind_query($table,$sql,$array)
	{
		$qr=$this->db->prepare("select * from ".PRE."$table ".$sql);
		$qr->execute($array);
		$this->results=$qr->fetchAll(PDO::FETCH_ASSOC);
		
		echo "select * from ".PRE."$table {$sql}";
	}
	public function select_single_query($table,$sql,$array)
	{
		$this->results=NULL;
		$qr=$this->db->prepare("select count(*) from ".PRE."$table {$sql}");
		$qr->execute($array);
		$tot=$qr->fetchColumn()/1;
		if($tot==1)
		{
			$this->select_single_item($table,$sql,$array);
		}else 
		{
			return NULL;
		}
	}
	public function select_single_item($table,$sql,$array)
	{
		$qr=$this->db->prepare("select * from ".PRE."$table {$sql} limit 0,1");
		$qr->execute($array);
		$this->results=NULL;
		$this->results = $qr->fetch();
	}
	public function insert_query($table,$set,$array)
	{
		$qr=$this->db->prepare("insert into ".PRE."$table set {$set}");
		$result=$qr->execute($array);
		if($result)
		{
			return true;
		}else 
		{
			return false;
		}
	}
	public function update_query($table,$set,$array)
	{
		$qr=$this->db->prepare("update ".PRE."$table set {$set}");
		$result=$qr->execute($array);
		if($result)
		{
			return true;
		}else 
		{
			return false;
		}
	}
	public function delete_query($table,$sql,$array)
	{
		$qr=$this->db->prepare("delete from ".PRE."$table {$sql}");
		$result=$qr->execute($array);
		if($result)
		{
			return true;
		}else 
		{
			return false;
		}
	}
	public function select_total_records($table,$sql,$array)
	{
		$total=$this->db->prepare("select count(*) from ".PRE.$table." {$sql}");
		$total->execute($array);
		$tot=$total->fetchColumn()/1;
		return $tot;
	}
}
?>