<?php 

class Media extends Controller 
{
	public $extra=NULL;
	public $results=NULL;
	public $author=NULL;
	public function __construct()
	{
		$this->setNewPerPage();
		$this->listPerPage();
		$this->getAuthor();
	}
	public function getAuthor()
	{
		global $session;
		$this->author=$session->userInfo["id"];
	}
	public function admin()
	{
		global $session;
		if($session->userInfo["rank"]=="admin"){return true;}else{return false;}
	}
	public function adminEditor()
	{
		global $session;
		if($session->userInfo["rank"]=="admin" or $session->userInfo["rank"]=="editor"){return true;}else{return false;}
	}
	public function listing()
	{
		$this->load($this->view("view/media/home"));
	}
	public function edit()
	{
		$this->load($this->view("view/media/edit"));
	}
	public function loadFrame(){
		$this->load($this->view("view/media/loadFrame"));
	}
	public function uploadMedias()
	{
		if(isset($_POST["fileUpload"]))
		{
			$tot=count($_FILES["medias"]["name"]);
			for($x=0; $x<$tot; $x++)
			{
				$realName=$_FILES["medias"]["name"][$x];
				$clearedName=$this->clear($realName);
				$suffix=explode(".",$clearedName);
				$totPoints=count($suffix);
				$lastPoint=$totPoints-1;
				$suffix=$suffix[$lastPoint];
				$newName=$this->setRand().".".$suffix;
				$dir=ROOT."uploads/".$newName;
				$mimeType=$_FILES["medias"]["type"][$x];
				$type=$this->getType($mimeType);
				$copy=move_uploaded_file($_FILES["medias"]["tmp_name"][$x],$dir);
				
				if($copy)
				{
					$set="title=?, url=?, type=?, mime_type=?, media_date=?,media_author=?";
					$array=array($realName,$newName,$type,$mimeType,date("d.m.Y")." - ".date("H:i:s"),$this->author);	
					$query=new Model();
					$insert=$query->insert_query("media",$set,$array);
				}	
			}
		}
	}
	public function uploadframe()
	{
		$this->uploadMedias();
	}
	public function editMedia()
	{
		if(isset($_POST["fileUpload"]))
		{
			$url=$this->results["url"];
			$aut=$this->results["media_author"];
			if($this->adminEditor() or $aut==$this->author)
			{
				$title=trim($_POST["title"]);
				$readFile=ROOT."uploads/".$url;
				$size=$_FILES["medias"]["size"];
				if($size!=0)
				{	
					if(file_exists($readFile))
					{
						unlink($readFile);
					}
					$realName=$_FILES["medias"]["name"];
					$clearedName=$this->clear($realName);
					$suffix=explode(".",$clearedName);
					$totPoints=count($suffix);
					$lastPoint=$totPoints-1;
					$suffix=$suffix[$lastPoint];
					$newName=$this->setRand().".".$suffix;
					$dir=ROOT."uploads/".$newName;
					$mimeType=$_FILES["medias"]["type"];
					$type=$this->getType($mimeType);
					$copy=move_uploaded_file($_FILES["medias"]["tmp_name"],$dir);
					
					if($copy)
					{
						if($title!=NULL or $title!="")
						{
							$realName=$title;
						}
						$set="title=?, url=?, type=?, mime_type=?, media_date=? where id=?";
						$array=array($realName,$newName,$type,$mimeType,date("d.m.Y")." - ".date("H:i:s"),$this->results["id"]);	
						$query=new Model();
						$update=$query->update_query("media",$set,$array);
						header("location:".URL."/media/edit&id=".$this->results["id"]);
					}	
				}else 
				{
					$set="title=? where id=?";
					if($title==NULL or $title=="")
					{
						$title=$this->results["title"];
					}
					$array=array($title,$this->results["id"]);	
					$query=new Model();
					$update=$query->update_query("media",$set,$array);
					header("location:".URL."/media/edit&id=".$this->results["id"]);
				}
			}
		}
	}
	public function getType($mime)
	{
		$mimes=array
		(
			"image/jpeg"=>"image",
			"image/jpg"=>"image",
			"image/png"=>"image",
			"image/gif"=>"image",
			"image/pjpeg"=>"image",
			"image/svg+xml"=>"image",
			"audio/mp4"=>"audio",
			"audio/aac"=>"audio",
			"audio/wav"=>"audio",
			"audio/mp3"=>"audio",
			"audio/mpeg"=>"audio",
			"audio/ogg"=>"audio",
			"audio/webm"=>"audio",
			"audio/x-ms-wma"=>"audio",
			"video/mp4"=>"video",
			"video/ogg"=>"video",
			"video/webm"=>"video",
			"video/x-ms-wmv"=>"video",
		);
		if(array_key_exists($mime,$mimes))
		{
			return $mimes[$mime];
		}else 
		{
			return "other";
		}
	}
	public function setRand()
	{
		$char=array
		(
			"a","b","c","d","e","f","g","h","i","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
			"A","B","C","D","E","F","G","H","I","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
			0,1,2,3,4,5,6,7,8,9			
		);
		$key=NULL;
		for($i=0;$i<20;$i++)
		{
			$num=rand(0,59);
			$key.=$char[$num];
		}
		return $key;
	}
	public function getTotalMedias()
	{
		$getTotal=new Model();
		$types=array("image","audio","video","other");
		if(isset($_GET["type"]) and in_array($_GET["type"],$types))
		{
			if(isset($_GET["user"]))
			{
				$sql="where type=? and media_author=?";
				$ar=array($_REQUEST["type"],$this->author);
			}else
			{
				$sql="where type=?";
				$ar=array($_REQUEST["type"]);
			}
		}else 
		{
			if(isset($_GET["user"]))
			{
				$sql="where media_author=?";
				$ar=array($this->author);
			}else
			{
				$sql=NULL;
				$ar=NULL;
			}
		}
		$total=$getTotal->select_total_records("media",$sql,$ar);
		return $total;
	}
	public function basicSettings()
	{
		if(isset($_POST["media_per_page"]))
		{
			$setValue=abs($_POST["media_per_page"]);
			$update=new Model();
			$update=$update->update_query("settings","set_value=? where set_name=?",array($setValue,"media_per_page"));
			if($update){header("location:".URL."/media/listing");}
		}
		$getSet=new Model();
		$getSet->select_single_query("settings","where set_name=?",array("media_per_page"));
		$value=$getSet->results["set_value"];
		return "<form action='' method='post'>
				<label>Her sayfada</label>
				<input type='number' name='media_per_page' value='".$value."'>
				<button>Kayıt Göster</button>
				</form>";
	}
	public function getAllMedias()
	{
		$totalPages=ceil($this->getTotalMedias()/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$start=($pageNum*($this->listPerPage))-($this->listPerPage);
		$per=$this->listPerPage;
		$paginationResult="Toplam dosya = <b>".$this->getTotalMedias()."</b>; Toplam sayfa = <b>".$totalPages."</b>";
		$this->extra=$paginationResult;
		if(isset($_GET["by"])){$by=$_GET["by"];}else{$by="id";}
		$protected_by=array("title","id","type");
		$protected_order=array("asc","desc");
		if(!in_array($by,$protected_by)){$by="id";}
		if(isset($_GET["order"])){$order=$_GET["order"];}else{$order="desc";}
		if(!in_array($order,$protected_order)){$order="asc";}
		$orderBy="order by ".$by." ".$order;
		$limit=$orderBy." limit ".$start.",".$this->listPerPage;
		$types=array("image","audio","video","other");
		
		if(isset($_GET["type"]) and in_array($_GET["type"],$types))
		{
			if(isset($_GET["user"]))
			{
				$sql="where type=? and media_author=?".$limit;
				$ar=array($_GET["type"],$this->author);
			}else
			{
				$sql="where type=? ".$limit;
				$ar=array($_GET["type"]);
			}
		}else 
		{
			if(isset($_GET["user"]))
			{
				$sql="where media_author=?".$limit;
				$ar=array($this->author);
			}else
			{
				$sql=$limit;
				$ar=NULL;
			}
		}
		$getAll=new Model();
		$getAll->fetch_query("media",$sql,$ar);
		$this->allCategories=$getAll->results;
		foreach ($this->allCategories as $row)
		{
			$fileRender=$this->fileRender($row["url"],$row["type"]);
			if($this->adminEditor() or $row["media_author"]==$this->author)
			{
				$checkbox="<input type='checkbox' name='selected[]' value='".$row["id"]."'>";
			}else
			{
				$checkbox=NULL;
			}
			echo "<tr>
					<td>".$checkbox."</td>
					<td><a href='".URL."/media/edit&id=".$row["id"]."'>".$fileRender."</a></td>
					<td>".$row["title"]."</td>
					<td>".$this->setType($row["type"])."</td>
					<td class='td_actions'><a href='".URL."/media/edit&id=".$row["id"]."'>Düzenle</a></td>
			     </tr>";
			$fileRender=NULL;
		}
	}
	public function setType($type)
	{
		$types=array("image" => "Resim", "video" => "Video", "audio" => "Ses dosyası", "other" =>"Diğer dosya");
		if(array_key_exists($type,$types))
		{
			return $types[$type];
		}else 
		{
			return "Çözülemedi !!!";
		}
	}
	public function videoRender($url)
	{
		$dir=URL."/plugins/media/video.png";
		return "<img src='".$dir."'>";
	}
	public function audioRender($url)
	{
		$dir=URL."/plugins/media/audio.png";
		return "<img src='".$dir."'>";
	}
	public function imageRender($url)
	{
		$dir=URL."/uploads";
		return "<img src='".$dir."/".$url."'>";
	}
	public function otherRender($url)
	{
		$dir=URL."/plugins/media/file.png";
		return "<img src='".$dir."'>";
	}
	public function fileRender($url,$type)
	{
		$func=$type."Render";
		return $this->$func($url);
	}
	public function table_title($sql_title,$text)
	{
		if(isset($_GET["order"])){$order=$_GET["order"];}else {$order="asc";}
		if(isset($_GET["user"])){$user="&user";}else{$user=NULL;}
		if(isset($_GET["by"])){$by=$_GET["by"];}else {$by="id";}
		if($by==$sql_title){$class="active_column";}else {$class="passive_column";}
		if(isset($_GET["type"])){$type="&type=".$_GET["type"];}else {$type=NULL;}
		if($order=="asc"){$class="class='".$class." order_asc'";}else{$class="class='".$class." order_desc'";}
		$totalPages=ceil($this->getTotalMedias()/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		if($order=="asc")
		{
			return "<a href='".URL."/media/listing".$user.$type."&by=$sql_title&order=desc&p=".$pageNum."' $class>".$text."</a>";
		}else
		{
			return "<a href='".URL."/media/listing".$user.$type."&by=$sql_title&order=asc&p=".$pageNum."' $class>".$text."</a>";
		}
	}
	public function pagination()
	{
		$total=$this->getTotalMedias();
		if(isset($_GET["user"])){$user="&user";}else{$user=NULL;}
		if(isset($_GET["by"])){$by="&by=".$_GET["by"];}else{$by=NULL;}
		if(isset($_GET["order"])){$order="&order=".$_GET["order"];}else{$order=NULL;}
		if(isset($_GET["type"])){$type="&type=".$_GET["type"];}else {$type=NULL;}
		$link=URL."/media/listing".$user.$type.$by.$order;
		$total=ceil($total/$this->listPerPage);
		$getAllPages=$this->getPagination($total,$link);
		$pagilinks=NULL;
		foreach ($getAllPages as $x)
		{
			$pagilinks.=$x;
		}
		return $pagilinks;
	}
	public function titleType()
	{
		$totalPages=ceil($this->getTotalMedias()/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$by_ar=array("title","type","id");
		$order_ar=array("asc","desc");
		if(isset($_GET["by"]) and in_array($_GET["by"],$by_ar)){ $by="&by=".$_GET["by"]; }else {$by="&by=id";}
		if(isset($_GET["order"]) and in_array($_GET["order"],$order_ar)){$order="&order=".$_GET["order"];}else {$order="&order=asc";}
		if(isset($_GET["user"])){$user="&user";}else{$user=NULL;}
		$page="&p=".$pageNum;
		$andlink=$user.$by.$order.$page;
		$types=array("all","image","audio","video","other");
		if(isset($_GET["type"]) and in_array($_GET["type"],$types)){$currentType=$_GET["type"];}else {$currentType="all";}
		$option=NULL;
		foreach ($types as $i)
		{
			if($i==$currentType)
			{
				$sc="selected='selected'";
			}else 
			{
				$sc=NULL;
			}
			if($i=="all")
			{
				$option.="<option value='".URL."/media/listing".$andlink."' $sc>Tüm dosyalar</option>";	
			}else
			{
				$option.="<option value='".URL."/media/listing&type=".$i.$andlink."' $sc>".$this->setType($i)."</option>";
			}
		}
		return $option;
	}
	public function getWithId()
	{
		if(isset($_GET["id"]))
		{
			$get=new Model();
			$get->select_single_query("media","where id=?",array($_GET["id"]));
			$this->results=$get->results;
			if(count($this->results)==0)
			{
				header("location:".URL."/media/listing");
			}
		}else 
		{
			header("location:".URL."/media/listing");
		}
	}
	public function showMedia()
	{
		$row=$this->results;
		if($row["type"]=="image")
		{
			
			return "<img src='".URL."/uploads/".$row["url"]."'>";	
		}elseif($row["type"]=="audio")
		{
			return "<audio controls>
						<source src='".URL."/uploads/".$row["url"]."' type='".$row["mime_type"]."'>
						Tarayıcınız HTML 5 ses elementini desteklemiyor.
					</audio>
				   ";
		}elseif($row["type"]=="video")
		{
			return "<video controls>
						<source type='".$row["mime_type"]."' src='".URL."/uploads/".$row["url"]."'>
						Tarayıcınız HTML 5 video elementini desteklemiyor.
					</video>
					";
		}
	}
	public function getOrderedObject()
	{
		$id=$this->results["id"];
		$query=new Model();
		$query->select_single_item("media","where id <? order by id desc",array($id));
		
		if(count($query->results["id"])==0)
		{
			$query=NULL;
			$query=new Model();
			$query->select_single_item("media","order by id desc",array($id));
		}
		$prev="<a href='".URL."/media/edit&id=".$query->results["id"]."'>Önceki</a>";
		$query=NULL;
		$query=new Model();
		$query->select_single_item("media","where id >? order by id asc",array($id));
		if(count($query->results["id"])==0)
		{
			$query=NULL;
			$query=new Model();
			$query->select_single_item("media","order by id asc",array($id));	
		}
		$next="<a href='".URL."/media/edit&id=".$query->results["id"]."'>Sonraki</a>";
		return $prev.$next;
	}
	public function deleteMedias()
	{
		if(isset($_POST["selected"]))
		{
			$tot=count($_POST["selected"]);
			if($tot>0)
			{
				$messages=NULL;
				foreach ($_POST["selected"] as $id)
				{
					$query=new Model();
					$query->select_single_query("media","where id=?",array($id));
					$url=$query->results["url"];
					$title=$query->results["title"];
					$mediaAut=$query->results["media_author"];
					if($this->adminEditor() or $this->author==$mediaAut)
					{
						$file=ROOT."uploads/".$url;
						if(strlen($url)>0)
						{
							if(file_exists($file))
							{
								unlink($file);
							}
							$query=new Model();
							$sqlDel=$query->delete_query("media","where id=?",array($id));
							if($sqlDel){$messages.="<b>".$title."</b> Silindi<br>";}
							$query=NULL;
						}
					}else
					{
						$messages.="<b style='color:red'>$title silme yetkiniz yok</b><br>";
					}
				}
				if($messages!=NULL or $messages!="")
				{
					$result=$this->formResults($messages);
					echo $result;
				}
			}
		}
	}
	public function mediaTypes(){
		$ar=array("image","audio","video","other");
		return $ar;
	}
	public function loadMediaForFrame()
	{
		if(isset($_GET["type"]))
		{
			if(in_array($_GET["type"],$this->mediaTypes()))
			{
				$this-> loadFrameMedia();
			}
		}else 
		{
			echo "yokk";
		}
	}
	public function getFrameTotalMedias()
	{
		$getTotal=new Model();
		$types=array("image","audio","video","other");
		if(isset($_GET["type"]) and in_array($_GET["type"],$types))
		{
			if(isset($_GET["search"]))
			{
				$sql="where type=? and title like ?";
				$ar=array($_GET["type"],"%".$_GET["search"]."%");
			}else
			{
				$sql="where type=?";
				$ar=array($_GET["type"]);
			}
		}else 
		{
			$sql=NULL;
			$ar=NULL;
		}
		$total=$getTotal->select_total_records("media",$sql,$ar);
		return $total;
	}
	public function loadFrameMedia()
	{
		$itemPer=21;
		$this->listPerPage=$itemPer;
		$totalMedias=$this->getFrameTotalMedias();
		$totalPages=ceil($totalMedias/$itemPer);
		$pageNum=$this->getPageNum($totalPages);
		$start=($pageNum*($itemPer))-($itemPer);
		$paginationResult="Toplam dosya = <b>".$totalMedias."</b>; Toplam sayfa = <b>".$totalPages."</b>";
		$this->extra=$paginationResult;
		$orderBy="order by id desc";
		$limit=$orderBy." limit ".$start.",".$itemPer;
		$types=array("image","audio","video","other");
		if(isset($_GET["search"]))
		{	
			if(strlen(trim($_GET["search"]))>0)
			{
				$search=trim($_GET["search"]);
			}else
			{
				$search="";
			}
		}else 
		{
			$search="";
		}
		if(isset($_GET["type"]) and in_array($_GET["type"],$types))
		{
			if(strlen($search)>0 and $search!=NULL)
			{
				$sql="where type=? and title like ? ".$limit;
				$ar=array($_GET["type"],"%".$search."%");
			}else
			{
				$sql="where type=? ".$limit;
				$ar=array($_GET["type"]);
			}
		}else 
		{
			if(strlen($search)>0 and $search!=NULL)
			{
				$sql="where title like ? ".$limit;
				$ar=array("%".$search."%");
			}else
			{
				$sql=$limit;
				$ar=NULL;
			}
		}
		$getAll=new Model();
		$getAll->fetch_query("media",$sql,$ar);
		$allMedias=$getAll->results;
		if(count($allMedias)>0)
		{
			foreach ($allMedias as $row)
			{
				$dataUrl=$this->getDataUrl($row["type"],$row["url"]);
				echo "<div class='mediaFrameRenderBox' id='".$row["id"]."' data-media='".$row["type"]."' data-media-type='".$row["mime_type"]."'>
					  <p>".mb_substr($row["title"],0,30)."</p>
					  <div class='mediaThumb' data-upload='".URL."/uploads/".$row["url"]."' data-url='".$dataUrl."'></div>
					  </div>";
				$fileRender=NULL;
			}
		}
	}
	public function loadMediaPagi()
	{
		$total=$this->getFrameTotalMedias();
		if(isset($_GET["by"])){$by="&by=".$_GET["by"];}else{$by=NULL;}
		if(isset($_GET["order"])){$order="&order=".$_GET["order"];}else{$order=NULL;}
		if(isset($_GET["type"])){$type="&type=".$_GET["type"];}else {$type=NULL;}
		$link=URL."/media/loadFrame".$type.$by.$order;
		$total=ceil($total/$this->listPerPage);
		$getAllPages=$this->getPagination($total,$link);
		$pagilinks=NULL;
		foreach ($getAllPages as $x)
		{
			$pagilinks.=$x;
		}
		return $pagilinks;
	}
	public function getDataUrl($type,$url)
	{
		switch ($type)
		{
			case "image": return URL."/uploads/".$url; break;
			case "video": return URL."/plugins/media/video.png"; break;
			case "audio": return URL."/plugins/media/audio.png"; break;
			case "other": return URL."/plugins/media/file.png"; break;
			default : return URL."/plugins/media/file.png"; break;
		}
	}
}

?>