<?php 

class Page extends Controller
{
	public $belowCats=array();
	public $row=array();
	public $totalRecords=0;
	public $paginationResult=NULL;
	public function listing()
	{
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->deletePages();
		$this->totalRecords();
		$this->load($this->view("view/page/home"));
		$this->load($this->view("view/common/footer"));
	}
	public function add()
	{
		$this->addPage();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/page/add"));
		$this->load($this->view("view/common/footer"));
	}
	public function deletePages()
	{
		if(isset($_POST["selected"]))
		{
			$messages=NULL;
			$query=new Model();
			foreach($_POST["selected"] as $id)
			{
				$query->select_single_query("page","where id=?",array($id));
				$title=$query->results["title"];
				$del=$query->delete_query("page","where id=?",array($id));
				if($del) {$messages.="<b>".$title."</b> silindi</br>";}
			}
			if($messages!=NULL){echo $this->formResults($messages);}
		}
	}
	public function getPageInfo()
	{
		$query=new Model();
		$query->select_single_query("page","where id=?",array($_GET["id"]));
		$this->row=$query->results;
	}
	public function edit()
	{
		if(isset($_GET["id"]))
		{
			$id=abs($_GET["id"]);
			$query=new Model();
			$tot=$query->select_total_records("page","where id=?",array($id));
			if($tot==1)
			{
				$this->editPage();
				$this->getPageInfo();
				$this->load($this->view("view/common/header"));
				$this->load($this->view("view/common/left_column"));
				$this->load($this->view("view/page/edit"));
				$this->load($this->view("view/common/footer"));
			}else 
			{
				header("location:".URL."/page/listing");
			}
		}else
		{
			header("location:".URL."/page/listing");
		}
	}
	public function setParentOptions($id,$self)
	{
		$query=new Model();
		$query->fetch_query("page",NULL,NULL);
		$results=$query->results;
		$options=NULL;
		$ana=array("id"=>0,"title"=>"Ebeveyn Yok");
		foreach ($results as $row)
		{
			$this->getBelows($self);
		}
		array_unshift($results,$ana);
		foreach ($results as $value)
		{
			if(!in_array($value["id"],$this->belowCats) or $value["id"]==0)
			{
				if($value["id"]==$id){$sc="selected='selected'";}else{$sc=NULL;}
				$options.="<option value='".$value["id"]."' $sc>".$value["title"]."</option>";
			}
		}
		$query=NULL;
		return $options;
	}
	public function getBelows($id)
	{
		$query=new Model();
		$tot=$query->select_total_records("page","where parent_id=?",array($id));
		if($tot==0)
		{
			if(!in_array($id,$this->belowCats))
			{
				array_push($this->belowCats,$id);
			}
		}else
		{
			$query->fetch_query("page","where parent_id=?",array($id));
			$results=$query->results;
			if(!in_array($id,$this->belowCats))
			{
				array_push($this->belowCats,$id);
			}
			foreach($results as $row)
			{
				$this->getBelows($row["id"]);
			}
		}
	}
	public function setSeflink($title,$post_title)
	{
		$title=$this->clear(trim($title));
		if(isset($_GET["id"]))
		{
			$id=$_GET["id"];
		}else 
		{
			$id=0;
		}
		$query=new Model();
		$result=$query->select_total_records("page","where id != ? and seflink = ?",array($id,$title));
		if($result==0)
		{
			$newSeflink=$this->clear($title);
		}else 
		{
			$query=NULL;
			$query=new Model();
			$result=$query->select_total_records("page","where title = ? and id != ?",array($post_title,$id));
			$newSeflink=$this->clear($title)."-".($result+1);
		}
		return $newSeflink;
	}
	public function getParent($id)
	{
		$query=new Model();
		$tot=$query->select_total_records("page","where id=?",array($id));
		if($tot==0)
		{
			return "<span class='mainCategoryText'>Ebeveyn yok</span>";
		}else 
		{
			$query->select_single_query("page","where id=?",array($id));
			return $query->results["title"];
		}
	}
	public function addPage()
	{
		if(isset($_POST["title"]) and strlen(trim($_POST["title"]))>0)
		{
			global $session;
			$parent_id=$_POST["parent_id"];
			$title=$_POST["title"];
			$content=$_POST["content"];
			$seflink=trim($_POST["seflink"]);
			if($seflink==NULL || $seflink=="")
			{
				$seflink=$this->setSeflink($title,$title);
			}else 
			{
				$seflink=$this->setSeflink($seflink,$seflink);
			}
			$image=$_POST["image"];
			$date=date("d M Y").";".date("H:i:s").";".time();
			$meta_title=$_POST["meta_title"];
			$meta_desc=$_POST["meta_desc"];
			$meta_tags=$_POST["meta_tags"];
			$page_author=$session->userInfo["id"];
			$page_template=$_POST["page_template"];
			$sort_order=$_POST["sort_order"];		
			$set="parent_id=?,title=?,content=?,seflink=?,image=?,date_creation=?,date_modified=?, meta_title=?, meta_desc=?, meta_tags=?, page_author=?, page_template=?, sort_order=?";
			$array=array($parent_id,$title,$content,$seflink,$image,$date,$date,$meta_title,$meta_desc,$meta_tags,$page_author,$page_template,$sort_order);
			$query=new Model();
			$add=$query->insert_query("page",$set,$array);
			if($add)
			{
				$query->select_single_query("page","where seflink=?",array($seflink));
				$id=$query->results["id"];
				header("location:".URL."/page/edit&id=".$id);
			}else 
			{
				echo $this->formResults("Kritik bir hata oluştu: sayfa eklenemedi!!!");
			}
			
		}
	}
	public function editPage()
	{
		if(isset($_POST["title"]) and strlen(trim($_POST["title"]))>0)
		{
			$parent_id=$_POST["parent_id"];
			$title=$_POST["title"];
			$content=$_POST["content"];
			$seflink=trim($_POST["seflink"]);
			if($seflink==NULL || $seflink=="")
			{
				$seflink=$this->setSeflink($title,$title);
			}else 
			{
				$seflink=$this->setSeflink($seflink,$seflink);
			}
			$image=$_POST["image"];
			$date_modified=date("d M Y").";".date("H:i:s").";".time();
			$meta_title=$_POST["meta_title"];
			$meta_desc=$_POST["meta_desc"];
			$meta_tags=$_POST["meta_tags"];
			$page_template=$_POST["page_template"];
			$sort_order=$_POST["sort_order"];		
			$set="parent_id=?,title=?,content=?,seflink=?,image=?,date_modified=?, meta_title=?, meta_desc=?, meta_tags=?, page_template=?, sort_order=? where id=?";
			$array=array($parent_id,$title,$content,$seflink,$image,$date_modified,$meta_title,$meta_desc,$meta_tags,$page_template,$sort_order,$_GET["id"]);
			$query=new Model();
			$edit=$query->update_query("page",$set,$array);
			if($edit)
			{
				header("location:".URL."/page/edit&id=".$id);
			}else 
			{
				echo $this->formResults("Kritik bir hata oluştu: sayfa güncellenemedi!!!");
			}
			
		}
	}
	public function getSingleImage($id)
	{
		$query=new Model();
		$query->select_single_query("media","where id=? and type=?",array($id,"image"));
		$row=$query->results;
		if($query->results)
		{
			$file=ROOT."uploads/".$row["url"];
			if(file_exists($file))
			{
				$url=URL."/uploads/".$row["url"];
			}else 
			{
				$url=URL."/plugins/media/image.png";
			}
			return "<img src='".$url."' title='".$row["title"]."' alt='".$row["title"]."'>";
		}else 
		{
			return "<img src='".URL."/plugins/media/image.png"."' title='resim yok'>";
		}
	}
	public function order()
	{
		return array("asc","desc");
	}
	public function by()
	{
		return array("id","title","parent_id","sort_order");
	}
	public function table_title($sql_title,$text)
	{
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order=$_GET["order"];}else {$order="asc";}
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->by())){$by=$_GET["by"];}else {$by="sort_order";}
		if($by==$sql_title){$class="active_column";}else {$class="passive_column";}
		if($order=="asc"){$class="class='".$class." order_asc'";}else{$class="class='".$class." order_desc'";}
		$totalPages=ceil($this->totalRecords/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		if($order=="asc")
		{
			return "<a href='".URL."/page/listing&by=$sql_title&order=desc&p=".$pageNum."' $class>".$text."</a>";
		}else
		{
			return "<a href='".URL."/page/listing&by=$sql_title&order=asc&p=".$pageNum."' $class>".$text."</a>";
		}
	}
	public function parentPage($id)
	{
		$query=new Model();
		$tot=$query->select_total_records("page","where id=?",array($id));
		if($tot==0)
		{
			return "Ebeveyn yok";
		}else
		{
			$query->select_single_query("page","where id=?",array($id));
			$title=$query->results["title"];
			$query=NULL;
			return  $title;
		}
		
	}
	public function listPages()
	{
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->by())){$by=$_GET["by"];}else{$by="sort_order";}
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order=$_GET["order"];}else{$order="asc";}
		$totalPages=ceil($this->totalRecords/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$by="order by ".$by." ".$order;
		$start=($pageNum*$this->listPerPage)-($this->listPerPage);
		$limit=" limit ".$start.",".$this->listPerPage;
		$this->paginationResult="Toplam afiş = <b>".$this->totalRecords."</b>; Toplam sayfa = <b>".$totalPages."</b> ";
		$query=new Model();
		$query->fetch_query("page",$by.$limit,NULL);
		$results=$query->results;
		foreach($results as $row)
		{
			$parent=$this->parentPage($row["parent_id"]);
			echo "<tr>
				  <td><input type='checkbox' name='selected[]' value='".$row["id"]."'></td>
				  <td>#".$row["id"]."</td>
				  <td>".htmlspecialchars($row["title"])."</td>
				  <td>".$parent."</td>
				  <td>".$row["sort_order"]."</td>
				  <td><a href='".URL."/page/edit&id=".$row["id"]."'>Düzenle</a></td>
				  </tr>";
		}
	}
	public function totalRecords()
	{
		$query=new Model();
		$tot=$query->select_total_records("page",NULL,NULL);
		$this->totalRecords=$tot;
		$query=NULL;
	}
	public function pagination()
	{
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order="&order=".$_GET["order"];}else {$order="&order=asc";}
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->by())){$by="&by=".$_GET["by"];}else {$by="&by=sort_order";}
		$totalPages=ceil($this->totalRecords/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$link=URL."/page/listing".$by.$order;
		$getAllPages=$this->getPagination($totalPages,$link);
		$pagilinks=NULL;
		foreach ($getAllPages as $x)
		{
			$pagilinks.=$x;
		}
		return $pagilinks;
	}
	public function pageTemplates($temp)
	{
		$template=$this->data["template"];
		require_once("../temp/".$template."/functions.php");
		$pageTemplates=page_templates();
		$option=NULL;
		foreach ($pageTemplates as $value => $text)
		{
			if($value==$temp){$sc="selected='selected'";}else{$sc=NULL;}
			$option.="<option value='".$value."' ".$sc.">".$text."</option>";
		}
		return $option;
	}
}
?>