<?php 
class Reservation extends Controller 
{	
	public function listing ()
	{
		$this->deleteAllReserves();
		$this->getTotalReserves();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/reservation/home"));
		$this->load($this->view("view/common/footer"));
	}
	public function deleteAllReserves(){
		if(isset($_POST["selected"]))
		{
			$query=new Model();
			foreach ($_POST["selected"] as $id)
			{
				$query->delete_query("reserve","where id=?",array($id));
			}
		}
	}
	public function getReserve()
	{
		if(isset($_GET["id"]))
		{
			$query=new Model();
			$tot=$query->select_total_records("reserve","where id=?",array(abs($_GET["id"])));
			if($tot==1)
			{
				$query->select_single_query("reserve","where id=?",array(abs($_GET["id"])));
				$this->row=$query->results;
			}else
			{
				header("location:".URL."/reservation/listing");	
			}
		}
	}
	public function getTotalReserves()
	{
		$query=new Model();
		$tot=$query->select_total_records("reserve",NULL,NULL);
		$this->getTotalReserves=$tot;
		$query=NULL;
	}
	public function getAllReserves()
	{
		$per=$this->listPerPage;
		$totalPages=ceil($this->getTotalReserves/$per);
		$pageNum=$this->getPageNum($totalPages);
		$start=($pageNum*($per))-($per);
		$paginationResult="Toplam kategori = <b>".$this->getTotalReserves."</b>; Toplam sayfa = <b>".$totalPages."</b>";
		$this->extra=$paginationResult;
		$query=new Model();
		$limit="limit ".$start." , ".$per;
		$query->fetch_query("reserve","order by id desc $limit",NULL);
		$results=$query->results;
		foreach($results as $row)
		{
			echo "<tr>
				  	<td><input type='checkbox' name='selected[]' value='".$row["id"]."'></td>
					<td>".$row["r_name"]."</td>
					<td>".$row["r_tel"]."</td>
					<td>".$row["r_date"]." - ".$row["r_hour"]."</td>
					<td><a href='".URL."/reservation/listing&id=".$row["id"]."'>Detay</a></td>
				  </tr>";
		}
	}
	public function pagination()
	{
		$total=$this->getTotalReserves;
		$link=URL."/reservation/listing";
		$total=ceil($total/$this->listPerPage);
		$getAllPages=$this->getPagination($total,$link);
		$pagilinks=NULL;
		foreach ($getAllPages as $x)
		{
			$pagilinks.=$x;
		}
		return $pagilinks;
	}
}
?>