<?php 
class Category extends Controller
{
	public $belows=array();
	public $set=NULL;
	public $ar=array();
	public $perPage=6;
	public $breadcrumb=NULL;
	public function __construct()
	{
		parent::__construct();
		
	}
	public function init($seflink)
	{
		$this->seflink=$seflink;
		if($this->total())
		{
			$this->category_details();
			$this->category_breadcrumb($this->cat_id);
			$this->get_below($this->cat_id);
			$this->set_ar();
			$this->total_posts();
			$this->get("category");
		}else
		{
			$this->get("error");
		}
	}
	public function set_ar()
	{
		$setsql=NULL;
		foreach($this->belows as $id)
		{
			if($setsql!=NULL)
			{
				$setsql.=",".$id;
			}else
			{
				$setsql=$id;
			}
		}
		$this->set=$setsql;
		/*
		$setsql=NULL;
		$arsql=array();
		foreach ($this->belows as $id)
		{
			if($setsql==NULL)
			{
				$setsql.="where post_category=?";
				array_push($arsql,$id);
			}else
			{
				$setsql.=" or post_category=?";
				array_push($arsql,$id);
			}
		}
		if($setsql==NULL)
		{
			$setsql.="where post_status=?";
			array_push($arsql,1);
		}else
		{
			$setsql.="and post_status=?";
			array_push($arsql,1);
		}
		$this->set=$setsql;
		$this->ar=$arsql;
		*/
	}
	public function total_posts()
	{
		
		$query=new Model();
		$tot=$query->select_total_records("posts","where post_category in (".$this->set.") and post_status=1",NULL);
		$this->total_posts=$tot;
		$query=NULL;	
	}
	public function pagination()
	{
		$totalPages=ceil($this->total_posts/$this->perPage);
		$pageNum=$this->getPageNum($totalPages);
		$link=URL."/category/".$this->cat_seflink;
		$getAllPages=$this->getPagination($totalPages,$link);
		$pagilinks=NULL;
		foreach ($getAllPages as $x)
		{
			$pagilinks.=$x;
		}
		return $pagilinks;
	}
	public function list_all_posts()
	{
		$totalPages=ceil($this->total_posts/$this->perPage);
		$pageNum=$this->getPageNum($totalPages);
		$start=($pageNum*$this->perPage)-($this->perPage);
		$limit=" limit ".$start." , ".$this->perPage;
		if($this->total_posts>0)
		{
			$query=new Model();
			$query->fetch_query("posts","where post_category in (".$this->set.") and post_status='1' order by post_id desc".$limit,NULL);
			$results=$query->results;
			$list=NULL;
			foreach($results as $row)
			{
				$post_link=URL."/post/".$row["post_seflink"];
				if(strlen($row["post_image"])>0)
				{
					$img_url=media_url($row["post_image"]);
					$img="<div class='list_post_image'>
							<a href='".$post_link."'>
							<img src='".$img_url."' alt='".$row["post_title"]."' title='".$row["post_title"]."'>
							</a>
						  </div>	
						  ";
				}else
				{
					$img=NULL;	
				}
				// $date_creation=post_date($row["date_creation"]);
				// $date_modified=post_date($row["date_modified"]);
				 $list.="<div class='list_post_inclose'>
					  		".$img."
							<div class='list_post_info_inclose'>
								<div class='list_post_title'>".$row["post_title"]."</div>
								<div class='list_post_summary'>".mb_substr(strip_tags($row["post_content"]),0,160)."...</div>
								<div class='list_post_link'>
									<a href='".$post_link."'>
										Devamı
									</a>
								</div>
							</div>
					    </div>";
			}
			$query=NULL;
			echo $list;
		}
	}
	public function get_below($id)
	{
		$query=new Model();
		$tot=$query->select_total_records("category","where parent_id=?",array($id));
		if($tot==0)
		{
			if(!in_array($id,$this->belows))
			{
				array_push($this->belows,$id);
			}
		}else
		{
			if(!in_array($id,$this->belows))
			{
				array_push($this->belows,$id);
			}
			$query->fetch_query("category","where parent_id=?",array($id));
			$results=$query->results;
			foreach($results as $row)
			{
				$this->get_below($row["id"]);
			}
		}
	}
	public function category_breadcrumb($id)
	{
		$query=new Model();
		$tot=$query->select_total_records("category","where id=?",array($id));
		if($tot==1)
		{
			$query->select_single_query("category","where id=?",array($id));
			$row=$query->results;
			$query=NULL;
			$breadcrumb=$this->breadcrumb;
			if($breadcrumb==NULL)
			{
				$this->breadcrumb="<a href='".URL."/category/".$row["seflink"]."'>".$row["title"]."</a>";
			}else
			{
				$this->breadcrumb="<a href='".URL."/category/".$row["seflink"]."'>".$row["title"]."</a> <span class='raquo'></span> ".$breadcrumb;
			}
			$this->category_breadcrumb($row["parent_id"]);
		}
	}
	public function total()
	{
		$query=new Model();
		$tot=$query->select_total_records("category","where seflink=?",array($this->seflink));
		$query=NULL;
		if($tot==1){return true;}else{return false;}
	}
	public function category_details()
	{
		$query=new Model();
		$query->select_single_query("category","where seflink=?",array($this->seflink));
		$row=$query->results;
		$query=NULL;
		foreach($row as $name=>$value)
		{
			$prefix="cat_".$name;
			$this->$prefix=$value;
		}
	}
	public function meta($name)
	{
		if($this->total())
		{
		$metas=array("title"=>$this->cat_meta_title,
					 "real_title"=>$this->cat_title,
					 "description"=>$this->cat_meta_desc,
					 "keywords"=>$this->cat_meta_tags,
					 "author"=>$this->settings["site_name"]
					 );
		if(array_key_exists($name,$metas))
		{
			if($name="title")
			{
				if(strlen($this->cat_meta_title)>0)
				{
					return $metas[$name];
				}else
				{
					return $metas["real_title"];
				}
			}else
			{
				return $metas[$name];
			}
		}else
		{
			return false;
		}
		}else
		{
			$metas=array("title"=>$this->settings["meta_title"],
						 "description"=>$this->settings["meta_desc"],
						 "keywords"=>$this->settings["meta_keys"],
						 "author"=>$this->settings["site_name"]
					 	);
			if(array_key_exists($name,$metas))
			{
				if($name="title")
				{
					if(strlen($this->settings["meta_title"])>0)
					{
						return $metas[$name];
					}else
					{
						return $metas["author"];
					}
				}else
				{
					return $metas[$name];
				}
			}else
			{
				return false;
			}
		}
	}
}
?>