<?php 
class Games extends Controller
{
	public $dates=array();
	public $days=array();
	public function init($seflink)
	{
		$query=new Model();
		$tot=$query->select_total_records("games","where seflink=?",array($seflink));
		if($tot==1)
		{
			$query->select_single_query("games","where seflink=?",array($seflink));
			$this->row=$query->results;
			$query=NULL;
			$this->setDates();
			$this->get("games");
		}else
		{
			$this->get("error");
		}
	}
	public function replace_tr($text)
	{
		$search=array("Mon","Tue","Wed","Thu","Fri","Sat","Sun",'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Sept','Oct','Nov','Dec');
		$change=array("Pazartesi","Salı","Çarşamba","Perşembe","Cuma","Cumartesi","Pazar",'Ocak','Şubat','Mart','Nisan','Mayıs','Haziran','Temmuz','Ağustos','Eylül','Eylül','Ekim','Kasım','Aralık');
		return str_replace($search,$change,$text);
	}
	public function setDates()
	{
		$days=$this->row["days"];
		$ex=explode(",",$days);
		$dates=NULL;
		for($x=0; $x<30; $x++)
		{
			$day=date("D", strtotime("+".$x." days"));
			if(in_array($day,$ex))
			{
				$date=date("d M Y D", strtotime("+".$x." days"));
				$newdate=$this->replace_tr($date);
				array_push($this->dates,$newdate);
			}
		}
	}
	public function getDateList()
	{
		foreach ($this->dates as $day)
		{
			echo "<div class='r_block'>";
			echo "<div class='r_date'>".$day."</div>";
			$hours=$this->row["hours"];
			$ex=explode(",",$hours);
			$query=new Model();
			foreach ($ex as $hour)
			{
				$hour=strip_tags($hour);
				$date_clear=strip_tags($this->clear($day));
				$hour_clear=$this->clear($hour);
				$tot=$query->select_total_records("reserve","where r_game=? and r_date_clear=? and r_hour_clear=?",array($this->row["seflink"],$date_clear,$hour_clear));
				if($tot==0)
				{
					echo "<div class='r_hour available' data-test='".$date_clear."' data-hour='".$hour."' data-date='".$day."'>".$hour." (Uygun)</div>";
				}else
				{
					echo "<div class='r_hour reserved' data-hour='".$hour."' data-date='".$day."'>".$hour." (Dolu)</div>";
				}
			}
			echo "</div>";
		}	
	}
	public function meta($name)
	{
		$metas=array("title"=>$this->settings["meta_title"],
					 "description"=>$this->settings["meta_desc"],
					 "keywords"=>$this->settings["meta_keys"],
					 "author"=>$this->settings["site_name"]
					 );
		if(array_key_exists($name,$metas))
		{
			if($name="title")
			{
				if(strlen($this->settings["meta_title"])>0)
				{
					return $metas[$name];
				}else
				{
					return $metas["author"];
				}
			}else
			{
				return $metas[$name];
			}
		}else
		{
			return false;
		}
	}
	public function getPrices()
	{
		$prices=$this->row["prices"];
		$ex=explode(",",$prices);
		foreach ($ex as $price)
		{
			$price_ex=explode(":",$price);
			$text=$price_ex[0];
			$value=$price_ex[1];
			echo "<div class='prices'>
				  	<div class='p_text'>".$text."</div>
					<div class='p_value'>".$value."</div>
				  </div>";
		}
	}
}
?>