<?php 
ob_start();
define('ROOT', str_replace("\\","/",dirname(__FILE__) . DIRECTORY_SEPARATOR));
require_once("../dbconfig.php");
require_once(ROOT."main/model.php");
require_once(ROOT."main/controller.php");
require_once(ROOT."main/config.php");
require_once(ROOT."main/user.php");
require_once("main/url.php");
session_start();
$session=new Session();
if($session->userLoged())
{	
	$commonDocument=ROOT."plugins/common/controller.php";
	define ("ROUTE",ROOT."plugins/".$route);
	if(is_dir(ROOT."plugins/".$route))
	{
		$document=ROOT."plugins/".$route."/controller.php";
		if(file_exists($document))
		{
			if($session->user_authority($route))
			{
				require_once($document);
				$start=new $route("controller");
				$start->$action();
			}else 
			{
				require_once($commonDocument);
				$start=new Common("controller");
				$start->errorPage();
			}
		}else 
		{
			require_once($commonDocument);
			$start=new Common("controller");
			$start->errorPage();
		}
	}else 
	{
		require_once($commonDocument);
		$start=new Common("controller");
		$start->errorPage();
	}
}else 
{
	$session->loginPage();
}
echo "<div id='l_route' data-location='".$route."'></div>";
ob_end_flush();

?>