<?php 
class Session 
{
	public $userInfo=NULL;
	public function __construct()
	{
		if($this->userLoged())
		{
			$query=new Model();
			$query->select_single_query("users","where id=?",array($_SESSION["user"]));
			$this->userInfo=$query->results;
		}
	}
	public function userLoged()
	{
		if(isset($_SESSION["user"]))
		{
			$query=new Model();
			$query->select_single_query("users","where id=?",array($_SESSION["user"]));
			$row=$query->results;
			if($row["status"]==0)
			{
				return false;
			}else
			{
				return true;
			}
		}else
		{
			return false;
		}
	}
	public function loginCheck()
	{
		$username=$_POST["username"];
		$password=md5($_POST["password"]);
		$query=new Model();
		$total=$query->select_total_records("users","where username=? or email=?",array($username,$username));
		if($total==0)
		{
			echo "<b>".$username."</b> diye bir kullanıcı bulunamadı.";
		}else
		{
			$query->select_single_query("users","where username=? or email=?",array($username,$username));
			$row=$query->results;
			$id=$row["id"];
			if($password==$row["password"])
			{
				$date="Tarih: ".date("d.m.Y")." Saat: ".date("H:i:s");
				$query->update_query("users","online=?, last_login=? where id=?",array(1,$date,$id));
				$_SESSION["user"]=$row["id"];
				echo "Bilgiler doğru girişiniz yapılıyor
					  <br>
					  <div class='progressBar'></div>
					  <script>setTimeout(function(){window.location.href='".URL."'},3000);</script>";
			}else 
			{
				echo "Şifreniz hatalı girdinizi. Lütfen kontrol ederek tekrar giriş yapmayı deneyin";
			}
		}
	}
	public function loginPage()
	{
		require_once(DIR_TEMPLATE."view/session/login.php");
	}
	public function setNewPassword()
	{
		if(isset($_POST["newPassword"]) and isset($_POST["rePassword"]) and isset($_POST["secure_key"]))
		{
			$query=new Model();
			$total=$query->select_total_records("recovery","where recovery_key=?",array($_POST["secure_key"]));
			if($total==1)
			{
				$query->select_single_query("recovery","where recovery_key=?",array($_POST["secure_key"]));
				$row=$query->results;
				$new=$_POST["newPassword"];
				$re=$_POST["rePassword"];
				if($new==$re)
				{
					$newPass=md5($new);
					$query->update_query("users","password=? where id=?",array($newPass,$row["user_id"]));
					$query->delete_query("recovery","where user_id=?",array($row["user_id"]));
					echo "Şifreniz değiştirildi. Giriş sayfasına yönlendiriliyorsunuz<br>
						  <div class='progressBar'></div>
						  <script>setTimeout(function(){window.location.href='".URL."'},3000);</script>";
				}else 
				{
					echo "Şifreler birbiriyle uyuşmuyor";
				}
			}else
			{
				echo "Geçersiz bağlantı.";
			}
		}else
		{
			return false;
		}
	}
	public function recoveryStatus()
	{
		if(isset($_GET["recovery"]))
		{
			$key=$_GET["recovery"];
			$query=new Model();
			$total=$query->select_total_records("recovery","where recovery_key=?",array($key));
			if($total==1)
			{
				$query->select_single_query("recovery","where recovery_key=?",array($key));
				$row=$query->results;
				$seconds=time()-$row["insert_time"];
				if($seconds<=60*61)
				{
					return true;
				}else
				{
					$query->delete_query("recovery","where user_id=?",array($row["user_id"]));
					return false;
				}
			}else
			{
				return false;
			}
		}else
		{
			return false;
		}
	}
	public function forgetPassword()
	{
		$user=$_POST["forgetPassword"];
		$query=new Model();
		$total=$query->select_total_records("users","where username=? or email=?",array($user,$user));
		if($total>0 and $total==1)
		{
			$query->select_single_query("users","where username=? or email=?",array($user,$user));
			$row=$query->results;
			$id=$row["id"];
			$query->delete_query("recovery","where user_id=?",array($id));
			$to=$row["email"];
			$member=$row["name"]." ".$row["surname"];
			$subject="Şifre sıfırlama bağlantısı";
			$rkey=md5(microtime());
			$time=time();
			$query->insert_query("recovery","recovery_key=?, insert_time=?, user_id=?",array($rkey,$time,$id));
			$rlink="<a href='".URL."/&recovery=".$rkey."'>".URL."/&recovery=".$rkey."</a>";
			$body="<h2>".$this->configs("site_name")." Şifre sıfırlama talebinden bulunduğunuz için bu maili aldınız.</h2>
				    <p>Şifrenizi değiştirmek istediğiniz için bu bağlantı size gönderilmiştir. </p>
					<p>Şifrenizi değiştirmek için bağlantıyı tıklayıp verilen adrese gitmeniz gerekiyor.</p> 
					<p>Bağlantı süresi devam ediyorsa açılacak olan forma yeni şifre bilgilerinizi girebilirsiniz.</p>
					<p>Güvenliğiniz için bağlantının maksimum açık olduğu süre 1 saattir. Bu süreden sonra link devredışı kalacaktır.</p>
				    <p>Sıfırlama bağlantısı : ".$rlink."</p>
				    <b>".$this->configs("site_name")."</b><br>
					<b>Saygılarımızla</b>
				  ";
			include ROOT."plugins/mail/class.phpmailer.php";
			include ROOT."plugins/mail/recovery.php";
		}else
		{
			echo $user." diye bir hesap bulunamadı";
		}
		
	}
	public function configs($setting)
	{
		$query=new Model();
		$query->select_single_query("settings","where set_name=?",array($setting));
		$row=$query->results;
		$query=NULL;
		return $row["set_value"];
	}
	public function wellcome()
	{
		$row=$this->userInfo;
		echo "<div id='wellcome'>Hoşgeldin <b>".$row["name"]."</b></div>
			  <div id='usernav'>
			  	<a href='".URL."/members/edit&id=".$row["id"]."'>Hesabım</a>
			  	<a href='".URL."/members/logout&id=".$_SESSION["user"]."'>Çıkış</a>
			  </div>
			 ";
	}
	public function setUserMenu($rank)
	{
		$modules=array(	"page"=>array("page","Sayfalar","listing"),
						"category"=>array("category","Kategoriler", "listing"),
					   	"media"=>array("media","Ortam Dosyaları","listing"),
						"games"=>array("games","Oyunlar","listing"),
						"reservation"=>array("reservation","Rezervasyon","listing"),
						"content"=>array("content","İçerikler","listing"),
						"menu"=>array("menu","Menüler","listing"),
						"service"=>array("service","Servisler","listing"),
						"banner"=>array("banner","Afişler","groups"),
						"members"=>array("members","Üyeler","listing"),
						"comments"=>array("comments","Yorumlar","listing"),
						"settings"=>array("settings","Ayarlar","update"),
					   );
		if($rank=="admin")
		{
			$set=array("page","category","content","games","reservation","media","banner","members","settings");
		}elseif($rank=="editor")
		{
			$set=array("media","content","comments");
		}elseif($rank=="writer")
		{
			$set=array("media","content","comments");
		}else 
		{
			$set=array();
		}
		$menu=NULL;
		foreach ($set as $link)
		{
			$class=$link;
			$text=$modules[$link][1];
			$method=$modules[$link][2];
			$menu.="<a href='".URL."/".$class."/".$method."' title='".$text."' id='l_".$link."'>".$text."</a>";
		}
		return $menu;
	}
	public function getUserMenu()
	{
		$menu=$this->setUserMenu($this->userInfo["rank"]);
		if(strlen($menu)>5)
		{
			return $menu;
		}else 
		{
			return false;
		}
		
	}
	public function user_authority($plugin)
	{
		$rank=$this->userInfo["rank"];
		$editor=array("comments","content","media","common","members");
		$writer=array("content","media","common","members");
		if($rank=="admin")
		{
			return true;
		}elseif($rank=="editor")
		{
			if(in_array($plugin,$editor))
			{
				return true;
			}else
			{
				return false;
			}
		}elseif($rank=="writer")
		{
			if(in_array($plugin,$writer))
			{
				return true;
			}else
			{
				return false;
			}
		}else
		{
			if($plugin=="members")
			{
				if(isset($_GET["id"]) and $this->userInfo["id"]==$_GET["id"])
				{
					return true;	
				}else
				{
					return false;
				}
			}else 
			{
				return false;
			}
		}
	}
}
?>