<?php 

class Comments extends Controller
{
	public $total=NULL;
	public $author=NULL;
	public $row=array();
	public $paginationResult=NULL;
	public function listing()
	{
		$this->getAuthor();
		$this->deleteComments();
		$this->total();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/comments/home"));
		$this->load($this->view("view/common/footer"));
	}
	public function loadEdit()
	{
		$ref=URL."/comments/listing";
		if(isset($_GET["id"]))
		{
			$query=new Model();
			$tot=$query->select_total_records("comments","where id=?",array(abs($_GET["id"])));
			if($tot>0)
			{
				$query->select_single_query("comments","where id=?",array(abs($_GET["id"])));
				$this->row=$query->results;
			}else
			{
				header("location:$ref");
			}
		}else
		{
			header("location:$ref");
		}
	}
	public function editComment()
	{
		if(isset($_POST["status"]))
		{
			$name=$_POST["name"];
			$status=$_POST["status"];
			$email=$_POST["email"];
			$comment=$_POST["comment"];
			if(strlen($comment)>1)
			{
				$query=new Model();
				$up=$query->update_query("comments","email=?, name=?, comment=?, status=? where id=?",array($email,$name,$comment,$status,abs($_GET["id"])));
				$req=$_SERVER["REQUEST_URI"];
				if($up){header("location:$req");}else{echo $this->formResults("Hata oluştu!!!");}
			}
		}
	}
	public function edit()
	{
		$this->editComment();
		$this->loadEdit();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/comments/edit"));
		$this->load($this->view("view/common/footer"));
	}
	public function getAuthor()
	{
		global $session;
		$this->author=$session->userInfo["id"];
	}
	public function admin()
	{
		global $session;
		if($session->userInfo["rank"]=="admin"){return true;}else{return false;}
	}
	public function adminEditor()
	{
		global $session;
		if($session->userInfo["rank"]=="admin" or $session->userInfo["rank"]=="editor"){return true;}else{return false;}
	}
	public function status()
	{
		return array(0,1);
	}
	public function total()
	{
		$query=new Model();
		if(isset($_GET["status"]) and in_array($_GET["status"],$this->status()))
		{
			$sql="where status=?";
			$ar=array($_GET["status"]);	
		}else 
		{
			$sql=NULL;
			$ar=NULL;
		}
		$this->total=$query->select_total_records("comments",$sql,$ar);
	}
	public function titleBy()
	{
		return array("email","name","post_id","status","time");
	}
	public function order()
	{
		return array("asc","desc");
	}
	public function table_title($sql_title,$text)
	{
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order=$_GET["order"];}else {$order="asc";}
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->titleBy())){$by=$_GET["by"];}else {$by="id";}
		if($by==$sql_title){$class="active_column";}else {$class="passive_column";}
		if(isset($_GET["status"]) and in_array($_GET["status"],$this->status())){$status="&status=".$_GET["status"];}else {$status=NULL;}
		if($order=="asc"){$class="class='".$class." order_asc'";}else{$class="class='".$class." order_desc'";}
		$totalPages=ceil($this->total/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		if($order=="asc")
		{
			return "<a href='".URL."/comments/listing".$status."&by=$sql_title&order=desc&p=".$pageNum."' $class>".$text."</a>";
		}else
		{
			return "<a href='".URL."/comments/listing".$status."&by=$sql_title&order=asc&p=".$pageNum."' $class>".$text."</a>";
		}
	}
	public function listComments()
	{
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order=$_GET["order"];}else {$order="asc";}
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->titleBy())){$by=$_GET["by"];}else {$by="id";}
		$totalPages=ceil($this->total/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$by="order by ".$by." ".$order;
		$start=($pageNum*$this->listPerPage)-($this->listPerPage);
		$limit=" limit ".$start.",".$this->listPerPage;
		if(isset($_GET["status"]) and in_array($_GET["status"],$this->status()))
		{
			$sql="where status=? ".$by.$limit;
			$ar=array($_GET["status"]);	
		}else 
		{
			$sql=$by.$limit;
			$ar=NULL;
		}
		$this->paginationResult="Toplam yorum = <b>".$this->total."</b>; Toplam sayfa = <b>".$totalPages."</b> ";
		$query=new Model();
		$query->fetch_query("comments",$sql,$ar);
		$results=$query->results;
		foreach ($results as $row)
		{
			if($this->adminEditor())
			{
				$checkbox="<input type='checkbox' name='selected[]' value='".$row["id"]."'>";
			}else
			{
				$checkbox=NULL;
			}
			echo "<tr>
					<td>".$checkbox."</td>
					<td>".$row["name"]."<br>".$row["email"]."</td>
					<td><div class='comments'>".$row["comment"]."</div></td>
					<td>".$this->getStatus($row["status"])."</td>
					<td>".$this->trDate($row["date"])."</td>
					<td class='td_actions'>
					<a href='".URL."/comments/edit&id=".$row["id"]."'>Düzenle</a>
					</td>
			     </tr>";
		}
	}
	public function trDate($text)
	{
		$en=array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Sept','Oct','Nov','Dec');
		$tr=array('Ocak','Şubat','Mart','Nisan','Mayıs','Haziran','Temmuz','Ağustos','Eylül','Eylül','Ekim','Kasım','Aralık');
		$newText=str_replace($en,$tr,$text);
		return $newText;
	}
	public function getStatus($status)
	{
		$sta=array("Onaysız","Onaylandı");
		return $sta[$status];
	}
	public function statusOption($opt)
	{
		$status=array("Onaysız","Onaylı");
		$options=NULL;
		foreach ($status as $value =>$name)
		{
			if($value==$opt){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$value."' $sc>".$name."</option>";
		}
		return $options;
	}
	public function deleteComments()
	{
		if($this->adminEditor())
		{
			if(isset($_POST["selected"]))
			{
				$messages=NULL;
				foreach($_POST["selected"] as $id)
				{
					$query=new Model();
					$query->select_single_query("comments","where id=?",array($id));
					$comment=$query->results["comment"];
					$query->results=NULL;
					$del=$query->delete_query("comments","where id=?",array($id));
					if($del)
					{
						$messages.=strip_tags($comment)." <b>silindi</b> <br>";
					}else
					{
						$messages.=strip_tags($comment)." <b>silinirken hata oluştu!!!</b><br>";
					}
				}
				if($messages!=NULL)
				{
					echo $this->formResults($messages);	
				}
			}
		}
	}
	public function pagination()
	{
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order="&order=".$_GET["order"];}else {$order="&order=asc";}
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->titleBy())){$by="&by=".$_GET["by"];}else {$by="&by=id";}
		if(isset($_GET["status"]) and in_array($_GET["status"],$this->status())){$status="&status=".$_GET["status"];}else {$status=NULL;}
		$totalPages=ceil($this->total/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$link=URL."/comments/listing".$status.$by.$order;
		$getAllPages=$this->getPagination($totalPages,$link);
		$pagilinks=NULL;
		foreach ($getAllPages as $x)
		{
			$pagilinks.=$x;
		}
		return $pagilinks;
	}
}