<?php 
class Common extends Controller
{	
	public function home()
	{
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/common/home"));
		$this->load($this->view("view/common/footer"));
	}
	public function errorPage()
	{
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/common/error"));
	}
	public function loadTotals($table,$set=NULL,$ar=NULL)
	{
		$query=new Model();
		$tot=$query->select_total_records($table,$set,$ar);
		return $tot;
	} 
	public function lastComments()
	{
		$query=new Model();
		$query->fetch_query("comments","limit 0,5",NULL);
		$results=$query->results;
		foreach ($results as $row)
		{
			$date=explode(";",$row["date"]);
			echo "<tr>
				  	<td>".$this->trDate("Tarih :".$date[0]." Saat : ".$date[1])."</td>
					<td>".mb_substr($row["comment"],0,100)."...</td>
					<td><a href='".URL."/comments/edit&id=".$row["id"]."'>Düzenle</a></td>
				  </tr>";
		}
	}
	public function trDate($text)
	{
		$en=array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Sept','Oct','Nov','Dec');
		$tr=array('Ocak','Şubat','Mart','Nisan','Mayıs','Haziran','Temmuz','Ağustos','Eylül','Eylül','Ekim','Kasım','Aralık');
		$newText=str_replace($en,$tr,$text);
		return $newText;
	}
	public function listReserve()
	{
		$query=new Model();
		$query->fetch_query("reserve","order by id desc limit 0,50",NULL);
		$results=$query->results;
		foreach($results as $row)
		{
			echo "<tr>
				  	<td>".$row["r_name"]."</td>
					<td>".$row["r_tel"]."</td>
					<td>".$row["r_date"]." - ".$row["r_hour"]."</td>
					<td><a href='".URL."/reservation/listing&id=".$row["id"]."'>Detay</a></td>
				  </tr>";
		}
	}
}
?>