<?php

class Games extends Controller
{
	public $total=NULL;
	public function listing ()
	{
		$this->deleteGames();
		$this->total();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/games/home"));
		$this->load($this->view("view/common/footer"));
	}
	public function deleteGames()
	{
		if(isset($_POST["selected"]))
		{
			$query=new Model();
			foreach ($_POST["selected"] as $id)
			{
				$query->delete_query("games","where id=?", array($id));
			}
			$query=NULL;
		}
	}
	public function total()
	{
		$query=new Model();
		$tot=$query->select_total_records("games",NULL,NULL);
		$this->total=$tot;
		$query=NULL;
	}
	public function listAllGames()
	{
		$query=new Model();
		$query->fetch_query("games","order by sort_order asc, id asc",NULL);
		$results=$query->results;
		$query=NULL;
		$list=NULL;
		foreach ($results as $row)
		{
			$image=$this->getSingleImage($row["image"]);
			$list.="<tr>
						<td><input type='checkbox' name='selected[]' value='".$row["id"]."'></td>
						<td>".$image."</td>
						<td><a href='".URL."/games/edit&id=".$row["id"]."'>".$row["name"]."</a></td>
						<td>".$row["sort_order"]."</td>
						<td><a href='".URL."/games/edit&id=".$row["id"]."'>Düzenle</a></td>
					</tr>";
		}
		return $list;
	}
	public function addGame()
	{
		if(isset($_POST["name"]))
		{
			if(count(trim($_POST["name"]))>0)
			{
			
				$seflink=$this->clear($_POST["name"]);
				$name=trim($_POST["name"]);
				$story=$_POST["story"];
				$rules=$_POST["rules"];
				$image=$_POST["image"];
				
				$days=NULL;
				foreach ($_POST["days"] as $day)
				{
					if($days==NULL){$days.=$day;}else{$days.=",".$day;}
				}
				$background_image=$_POST["background_image"];
				$hours=$_POST["hours"];
				$prices=$_POST["prices"];
				$sort_order=$_POST["sort_order"];
				$set="seflink=?, name=?, story=?, rules=?, image=?, background_image=?, days=?, hours=?, prices=?, sort_order=?";
				$ar=array($seflink,$name,$story,$rules,$image,$background_image,$days,$hours, $prices,$sort_order);
				$query=new Model();
				$result=$query->insert_query("games",$set,$ar);
				print_r($query);
				if($result)
				{
					$query->select_single_query("games","where seflink=?", array($seflink));
					$id=$query->results["id"];
					header("location:".URL."/games/edit&id=".$id);
				}
			}else
			{
				return false;
			}
		}
	}
	public function editGame()
	{
		if(isset($_POST["name"]))
		{
			if(count(trim($_POST["name"]))>0)
			{
				$seflink=$this->clear($_POST["name"]);
				$name=trim($_POST["name"]);
				$story=$_POST["story"];
				$rules=$_POST["rules"];
				$image=$_POST["image"];
				$days=NULL;
				foreach ($_POST["days"] as $day)
				{
					if($days==NULL){$days.=$day;}else{$days.=",".$day;}
				}
				$background_image=$_POST["background_image"];
				$hours=$_POST["hours"];
				$prices=$_POST["prices"];
				$sort_order=$_POST["sort_order"];
				$set="seflink=?, name=?, story=?, rules=?, image=?, background_image=?, days=?, hours=?, prices=?, sort_order=? where id=?";
				$ar=array($seflink,$name,$story,$rules,$image,$background_image,$days,$hours,$prices,$sort_order,$_GET["id"]);
				$query=new Model();
				$result=$query->update_query("games",$set,$ar);
				if($result)
				{
					header("location:".URL."/games/listing");
				}
			}else
			{
				return false;
			}
		}
	}
	public function add()
	{
		$this->addGame();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/games/add"));
		$this->load($this->view("view/common/footer"));
	}
	public function edit()
	{
		if(isset($_GET["id"]))
		{
			$id=abs($_GET["id"]);
		}else
		{
			$id=0;
		}
		$query=new Model();
		$tot=$query->select_total_records("games","where id=?",array($id));
		if($tot==1)
		{
			$query->select_single_query("games","where id=?",array($id));
			$this->row=$query->results;
			$this->editGame();
			$this->load($this->view("view/common/header"));
			$this->load($this->view("view/common/left_column"));
			$this->load($this->view("view/games/edit"));
			$this->load($this->view("view/common/footer"));
		}else
		{
			header("location:".URL."/games/listing");
		}
	}
	public function getSingleImage($id)
	{
		$query=new Model();
		$query->select_single_query("media","where id=? and type=?",array($id,"image"));
		$row=$query->results;
		if($query->results)
		{
			$file=ROOT."uploads/".$row["url"];
			if(file_exists($file))
			{
				$url=URL."/uploads/".$row["url"];
			}else 
			{
				$url=URL."/plugins/media/image.png";
			}
			return "<img src='".$url."' title='".$row["title"]."' alt='".$row["title"]."'>";
		}else 
		{
			return "<img src='".URL."/plugins/media/image.png"."' title='resim yok'>";
		}
	}
	public function getListedImage($id)
	{
		$query=new Model();
		$query->select_single_query("media","where id=? and type=?",array($id,"image"));
		$row=$query->results;
		if($query->results)
		{
			$file=ROOT."uploads/".$row["url"];
			if(file_exists($file))
			{
				$url=URL."/uploads/".$row["url"];
			}else 
			{
				$url=URL."/plugins/media/image.png";
			}
			return "<img src='".$url."' title='".$row["title"]."' alt='".$row["title"]."' class='singleImage'>";
		}else 
		{
			return "<img src='".URL."/plugins/media/image.png"."' title='resim yok' class='singleImage'>";
		}
	}
	public function getDays($days)
	{
		$ex=explode(",",$days);
		$weekdays=array("Mon"=>"Pazartesi", "Tue"=>"Salı","Wed"=>"Çarşamba","Thu"=>"Perşembe","Fri"=>"Cuma","Sat"=>"Cumartesi","Sun"=>"Pazar");
		$options=NULL;
		foreach ($weekdays as $day => $text)
		{
			if(in_array($day,$ex)){$ch="checked='checked'";}else{$ch=NULL;}
			$options.="<label><input type='checkbox' name='days[]' value='".$day."' ".$ch."> ".$text." </label>";
		}
		return $options;
	}
}
?>