<?php 
class Menu extends Controller
{
	public $row=NULL;
	public $belows=array();
	public $fetch=NULL;
	public function listing()
	{
		$this->deleteMenu();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/menu/menus"));
		$this->load($this->view("view/common/footer"));
	}
	public function updateTab()
	{
		if(isset($_POST["tab_id"]))
		{
			$query=new Model();
			$tot=$query->select_total_records("menutab","where id=?",array(abs($_POST["tab_id"])));
			if($tot>0)
			{
				$tab_id=abs($_POST["tab_id"]);
				$tab_title=$_POST["tab_title"];
				$tab_content=$_POST["tab_content"];
				$tab_parent=$_POST["tab_parent"];
				$tab_type=$_POST["tab_type"];
				$sort_order=abs($_POST["sort_order"]);
				$set="tab_parent=?, tab_title=?, tab_content=?, tab_type=?, sort_order=? where id=?";
				$ar=array($tab_parent,$tab_title,$tab_content,$tab_type,$sort_order,$tab_id);
				$up=$query->update_query("menutab",$set,$ar);
				$ref=$_SERVER["REQUEST_URI"];
				if($up){header("location:$ref");}
			}
		}
	}
	public function deleteTab()
	{
		if(isset($_POST["deleteTab"]))
		{
			$id=abs($_POST["deleteTab"]);
			$query=new Model();
			$tot=$query->select_total_records("menutab","where id=?",array($id));
			if($tot>0)
			{
				$req=$_SERVER["REQUEST_URI"];
				$query->select_single_query("menutab","where id=?",array($id));
				$parent=$query->results["tab_parent"];
				$update=$query->update_query("menutab","tab_parent=? where tab_parent=?",array($parent,$id));
				if($update)
				{
					$delete=$query->delete_query("menutab","where id=?",array($id));
					if($delete){header("location:$req");}
				}
			}
		}
	}
	public function updateMenuTitle()
	{
		if(isset($_POST["menu_title"]))
		{
			$title=trim($_POST["menu_title"]);
			if(strlen($title)>0)
			{
				$query=new Model();
				$query->update_query("menu","title=? where id=?",array($title,$_GET["id"]));
				$req=$_SERVER["REQUEST_URI"];
				header("location:$req");
			}
		}
	}
	public function edit()
	{
		$this->updateMenuTitle();
		$this->addUrlTab();
		$this->addPageTab();
		$this->addContentTab();
		$this->addCategoryTab();
		$this->deleteTab();
		$this->updateTab();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		if(isset($_GET["id"]))
		{
			$query=new Model();
			$tot=$query->select_total_records("menu","where id=?",array($_GET["id"]));
			if($tot==0)
			{
				$this->load($this->view("view/common/error"));
			}else 
			{
				$query->select_single_query("menu","where id=?",array($_GET["id"]));
				$this->row=$query->results;
				$this->load($this->view("view/menu/edit"));
			}
		}
		$this->load($this->view("view/common/footer"));
	}
	public function addCategoryTab() 
	{
		if(isset($_POST["cat_id"]))
		{
			$query=new Model();
			$tot=$query->select_total_records("category","where id=?",array($_POST["cat_id"]));
			if($tot!=0)
			{
				$query->select_single_query("category","where id=?",array($_POST["cat_id"]));
				$row=$query->results;
				$tab_type="category";
				$tab_content=$row["id"];
				$tab_title=$row["title"];
				$tab_parent=0;
				$req=$_SERVER["REQUEST_URI"];
				$set="menu_id=?, tab_parent=?, tab_title=?, tab_content=?, tab_type=?";
				$ar=array($_GET["id"],$tab_parent,$tab_title,$tab_content,$tab_type);
				$insert=$query->insert_query("menutab",$set,$ar);
				if($insert){header("location:$req");}
			}
		}
	}
	public function addContentTab() 
	{
		if(isset($_POST["post_id"]))
		{
			$query=new Model();
			$tot=$query->select_total_records("posts","where post_id=?",array($_POST["post_id"]));
			if($tot!=0)
			{
				$query->select_single_query("posts","where post_id=?",array($_POST["post_id"]));
				$row=$query->results;
				$tab_type="post";
				$tab_content=$row["post_id"];
				$tab_title=$row["post_title"];
				$tab_parent=0;
				$req=$_SERVER["REQUEST_URI"];
				$set="menu_id=?, tab_parent=?, tab_title=?, tab_content=?, tab_type=?";
				$ar=array($_GET["id"],$tab_parent,$tab_title,$tab_content,$tab_type);
				$insert=$query->insert_query("menutab",$set,$ar);
				if($insert){header("location:$req");}
			}
		}
	}
	public function addPageTab() 
	{
		if(isset($_POST["page_id"]))
		{
			$query=new Model();
			$tot=$query->select_total_records("page","where id=?",array($_POST["page_id"]));
			if($tot!=0)
			{
				$query->select_single_query("page","where id=?",array($_POST["page_id"]));
				$row=$query->results;
				$tab_type="page";
				$tab_content=$row["id"];
				$tab_title=$row["title"];
				$tab_parent=0;
				$req=$_SERVER["REQUEST_URI"];
				$set="menu_id=?, tab_parent=?, tab_title=?, tab_content=?, tab_type=?";
				$ar=array($_GET["id"],$tab_parent,$tab_title,$tab_content,$tab_type);
				$insert=$query->insert_query("menutab",$set,$ar);
				if($insert){header("location:$req");}
			}
		}
	}
	public function addUrlTab()
	{
		if(isset($_POST["url_tab"]))
		{
			$req=$_SERVER["REQUEST_URI"];
			$tab_title=$_POST["tab_title"];
			$tab_content=$_POST["tab_content"];
			if($tab_content!="" and $tab_title!="")
			{
				$set="menu_id=?, tab_parent=?, tab_title=?, tab_content=?, tab_type=?";
				$ar=array($_GET["id"],0,$tab_title,$tab_content,"link");
				$query=new Model();
				$query->insert_query("menutab",$set,$ar);
			}
			header("location:$req");
		}
	}
	public function newMenu()
	{
		if(isset($_POST["newMenu"]))
		{
			$time=time();
			$query=new Model();
			$add=$query->insert_query("menu","title=?, time=?",array($_POST["newMenu"],$time));
			if($add)
			{
				$query->select_single_query("menu","where time=?",array($time));
				$id=$query->results["id"];
				header("location:".URL."/menu/edit&id=".$id);
			}
		}
	}
	public function returnType($type)
	{
		switch($type)
		{
			case "category": return "Kategori"; break;
			case "post": return "İçerik"; break;
			case "link": return "Bağlantı"; break;
			case "page": return "Sayfa"; break;
			default:return "Çözülemedi";
		}
	}
	public function listTabs($parent)
	{
		$query=new Model();
		$query->results=NULL;
		$tot=$query->select_total_records("menutab","where id=?",array($parent));
		if($tot==1)
		{
			$query->select_single_query("menutab","where id=?",array($parent));
			$single=$query->results;
			
			$btot=$query->select_total_records("menutab","where tab_parent=?",array($parent));
			if($btot==0)
			{
				if($single["tab_parent"]==0)
				{
					$textSpan="<span class='mainMenuTab'>ana dizin</span>";
				}else 
				{
					$textSpan="<span class='belowMenuTab'>alt eleman</span>";
				}
				if($single["tab_type"]!="link")
				{
					$inputType="hidden";
					$display="none";
				}else
				{
					$display="block";
					$inputType="text";
				}
				echo "<li id='".$single["id"]."'>
					  <div class='singleTab' id='tab_".$single["id"]."'>
					  <div class='tabName'>".$single["tab_title"].$textSpan." 
					  	<div class='menuSettings'></div>
					  	<div class='menuType'>".$this->returnType($single["tab_type"])."</div>
					  </div>
					  <div class='tabForm'>
					  	<form action='' method='post'>
						<input type='hidden' value='".$single["tab_type"]."' name='tab_type'>
						<input name='tab_id' type='hidden' value='".$single["id"]."'>
					  	<label>Dolaşım etiketi</label>
					  	<input type='text' name='tab_title' value='".$single["tab_title"]."'>
						<label style='display:".$display."'>Adres</label>
						<input type='".$inputType."' name='tab_content' value='".$single["tab_content"]."'>
						".$this->selectTab($single["id"],$single["tab_parent"])."
						<label>Sıralama</label>
						<input type='text' name='sort_order' value='".$single["sort_order"]."' class='numeric'>
						<button class='tabMenuButton'>Güncelle</button>
					  	</form>
						<form action='' method='post'>
						<input name='deleteTab' value='".$single["id"]."' type='hidden'>
						<button class='tabMenuButton rightButton'>Kaldır</button>
						</form>
					  </div>
					  </div>
					  </li>";
			}elseif($btot>0)
			{
				$query->fetch_query("menutab","where tab_parent=?",array($single["id"]));
				$all=$query->results;
				if($single["tab_parent"]==0)
				{
					$textSpan="<span class='mainMenuTab'>ana dizin</span>";
				}else 
				{
					$textSpan="<span class='belowMenuTab'>alt eleman</span>";
				}
				if($single["tab_type"]!="link")
				{
					$inputType="hidden";
					$display="none";
				}else
				{
					$display="block";
					$inputType="text";
				}
				echo "<li id='".$single["id"]."'>
					  <div class='singleTab' id='tab_".$single["id"]."'>
					  <div class='tabName'>".$single["tab_title"].$textSpan." 
					  	<div class='menuSettings'></div>
					  	<div class='menuType'>".$this->returnType($single["tab_type"])."</div>
					  </div>
					  <div class='tabForm'>
					  	<form action='' method='post'>
						<input name='tab_id' type='hidden' value='".$single["id"]."'>
						<input type='hidden' value='".$single["tab_type"]."' name='tab_type'>
					  	<label>Dolaşım etiketi</label>
					  	<input type='text' name='tab_title' value='".$single["tab_title"]."'>
						<label style='display:".$display."'>Adres</label>
						<input type='".$inputType."' name='tab_content' value='".$single["tab_content"]."'>
						".$this->selectTab($single["id"],$single["tab_parent"])."
						<label>Sıralama</label>
						<input type='text' name='sort_order' value='".$single["sort_order"]."' class='numeric'>
						<button class='tabMenuButton'>Güncelle</button>
					  	</form>
						<form action='' method='post'>
						<input name='deleteTab' value='".$single["id"]."' type='hidden'>
						<button class='tabMenuButton rightButton'>Kaldır</button>
						</form>
					  </div>
					  </div>";
				
					foreach($all as $row)
					{
						echo "<ul>";
							$this->listTabs($row["id"]);
						echo "</ul>";	
					}
				echo "</li>";
			}
		}
	}
	public function getMainMenuTabs($id)
	{
		$query=new Model();
		$query->results=NULL;
		$query->fetch_query("menutab","where menu_id=? and tab_parent=? order by sort_order asc, id asc",array($id,0));
		$results=$query->results;
		foreach ($results as $row)
		{
			$this->listTabs($row["id"]);
		}
	}
	public function allBelows($id)
	{
		$query=new Model();
		$tot=$query->select_total_records("menutab","where tab_parent=?",array($id));
		array_push($this->belows,$id);
		if($tot!=0)
		{
			$query->fetch_query("menutab","where tab_parent=?",array($id));
			array_push($this->belows,$id);
			foreach ($query->results as $row)
			{
				if(!in_array($row["id"],$this->belows))
				{
					array_push($this->belows,$row["id"]);
				}
				$this->allBelows($row["id"]);
			}
		}
	}
	public function getBelows($self)
	{
		$this->allBelows($self);
		$all=$this->belows;
		$this->belows=array();
		return $all;
	}
	public function selectTab($self,$parent)
	{	
		$ana=array("id"=>0,"tab_title" => "Ana dizin", "tab_parent" => 0);
		$query=new Model();
		$query->fetch_query("menutab","where menu_id=?",array($_GET["id"]));
		$results=$query->results;
		$getBelows=$this->getBelows($self);
		array_unshift($results,$ana);
		$options=NULL;
		foreach ($results as $row)
		{
			if(!in_array($row["id"],$getBelows))
			{
				if($row["id"]==$parent)
				{
					$sc="selected='selected'";
				}else 
				{
					$sc=NULL;
				}
				$options.="<option value='".$row["id"]."' ".$sc.">".$row["tab_title"]."</option>";
			}
			$this->belows=array();
		}
		return "<label>Ana dizin</label>
				<select id='tab_parent' name='tab_parent'>".$options."</select>";
	}
	public function categorysearch()
	{
		$this->load($this->view("view/menu/categorysearch"));
	}
	public function postsearch()
	{
		$this->load($this->view("view/menu/postsearch"));
	}
	public function pagesearch()
	{
		$this->load($this->view("view/menu/pagesearch"));
	}
	public function categoryList()
	{
		if(isset($_GET["search"]))
		{
			$search=$_GET["search"];
		}else 
		{
			$search="";
		}
		$query=new Model();
		$query->fetch_query("category","where title like ? limit 0,10 ",array("%".$search."%"));
		$this->fetch=$query->results;
	}
	public function postList()
	{
		if(isset($_GET["search"]))
		{
			$search=$_GET["search"];
		}else 
		{
			$search="";
		}
		$query=new Model();
		$query->fetch_query("posts","where post_title like ? or post_content like ? limit 0,10 ",array("%".$search."%", "%".$search."%"));
		$this->fetch=$query->results;
	}
	public function pageList()
	{
		if(isset($_GET["search"]))
		{
			$search=$_GET["search"];
		}else 
		{
			$search="";
		}
		$query=new Model();
		$query->fetch_query("page","where title like ? or content like ? limit 0,10 ",array("%".$search."%", "%".$search."%"));
		$this->fetch=$query->results;
	}
	public function listAllMenus()
	{
		$query= new Model();
		$tot=$query->select_total_records("menu",NULL,NULL);
		if($tot==0){return false;}else{return true;}
	}
	public function listMenus()
	{
		$query=new Model();
		$query->fetch_query("menu","order by title asc",NULL);
		foreach($query->results as $row)
		{
			$link=URL."/menu/edit&id=".$row["id"];
			echo "<tr>
				 	<td><input type='checkbox' name='selected[]' value='".$row["id"]."'></td>
					<td><a href='".$link."'>".$row["title"]."</a></td>
					<td><a href='".$link."'>Düzenle</a></td>
				 </tr>";
		}
	}
	public function deleteMenu()
	{
		if(isset($_POST["selected"]))
		{
			$all=array();
			foreach ($_POST["selected"] as $id)
			{
				$query=new Model();
				$tot=$query->select_total_records("menu","where id=?",array($id));
				if($tot!=0 or $tot>0)
				{
					$deleteTab=$query->delete_query("menutab","where menu_id=?",array($id));
					if($deleteTab)
					{
						$query->select_single_query("menu","where id=?",array($id));
						$title=$query->results["title"];
						$deleteMenu=$query->delete_query("menu","where id=?",array($id));
						if($deleteMenu)
						{
							array_push($all,$title);
						}
					}
				}
			}
			$message=NULL;
			if(count($all)>0)
			{
				foreach ($all as $deleted)
				{
					$message.="<b>".$deleted."</b> silindi.";	
				}
				echo $this->formResults($message);
			}else 
			{
				$req=$_SERVER["REQUEST_URI"];
				header("location:$req");
			}
		}
	}
}

?>