<?php 

class Widgets extends Controller
{
	public $totalRecords=NULL;
	public $row=array();
	public function listing()
	{
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->addWidget();
		$this->deleteWidgets();
		$this->totalRecords();
		$this->load($this->view("view/widgets/home"));
		$this->load($this->view("view/common/footer"));
	}
	public function deleteWidgets()
	{
		if(isset($_POST["selected"]))
		{
			$query=new Model();
			$messages=NULL;
			foreach($_POST["selected"] as $id)
			{
				$tot=$query->select_total_records("widgets","where id=?",array(abs($id)));
				if($tot==1)
				{
					$query->select_single_query("widgets","where id=?",array(abs($id)));
					$title=$query->results["title"];
					$del=$query->delete_query("widgets","where id=?",array(abs($id)));
					if($del)
					{
						$messages.="<b>".$title."</b> silindi<br>";
					}else
					{
						$messages.="<b style='color:red'>".$title."</b> silinirken hata oluştu<br>";
					}
				}
			}
			echo $this->formResults($messages);
		}
	}
	public function edit()
	{
		if(isset($_GET["id"]))
		{
			$id=abs($_GET["id"]);
		}else
		{
			$id=0;
		}
		if($id==0){header("location:".URL."/widgets/listing");}
		$query=new Model();
		$tot=$query->select_total_records("widgets","where id=?",array($id));
		if($tot==0)
		{
			header("location:".URL."/widgets/listing");
		}
		else
		{
			$query->select_single_query("widgets","where id=?",array($id));
			$this->row=$query->results;
		}
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->editWidget();
		$this->load($this->view("view/widgets/edit"));
		$this->load($this->view("view/common/footer"));
	}
	public function loadEditForm($widget)
	{
		$file=ROOT."plugins/widgets/widgets/".$widget."/edit.php";
		if(file_exists($file)){include $file;}else {echo "Dosya bulunamadı";}
	}
	public function locationOption($current)
	{
		$this->tempFunc();
		$locations=template_parts();
		$options=NULL;
		foreach($locations as $value => $text)
		{
			if($value==$current){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$value."' $sc>".$text."</option>";
		}
		return $options;
	}
	public function editWidget()
	{
		if(isset($_POST["title"]))
		{
			$this->tempFunc();
			$locations=template_parts();
			$title=trim($_POST["title"]);
			if(strlen($title)>0)
			{
				$part=$_POST["location"];
				if(!array_key_exists($part,$locations)){$part=key($locations);}
				$widget=$_POST["widget"];
				$content=NULL;
				if(is_array($_POST["content"]))
				{
					foreach($_POST["content"] as $cid)
					{
						if($content==NULL)
						{
							$content.=$cid;
						}else
						{
							$content.=",".$cid;
						}
					}
				}else
				{
					$content=$_POST["content"];
				}
				$total=abs($_POST["total"]);
				$title_status=$_POST["title_status"];
				$sort_order=abs($_POST["sort_order"]);
				$set="location=?, widget=?, title=?, content=?, total=?, title_status=?, sort_order=? where id=?";
				$ar=array($part,$widget,$title,$content,$total,$title_status,$sort_order,$_GET["id"]);
				$query=new Model();
				$update=$query->update_query("widgets",$set,$ar);
				if($update){header("location:".URL."/widgets/listing&part=".$part);}
			}
		}
	}
	public function addWidget()
	{
		if(isset($_POST["title"]))
		{
			$this->tempFunc();
			$locations=template_parts();
			$title=trim($_POST["title"]);
			if(strlen($title)>0)
			{
				if(isset($_GET["part"]) and array_key_exists($_GET["part"],$locations))
				{
					$location=$_GET["part"];
				}else
				{
					$location=key($locations);
				}
				$req=$_SERVER["REQUEST_URI"];
				$widget=$_POST["widget"];
				$content=NULL;
				if(is_array($_POST["content"]))
				{
					foreach($_POST["content"] as $cid)
					{
						if($content==NULL)
						{
							$content.=$cid;
						}else
						{
							$content.=",".$cid;
						}
					}
				}else
				{
					$content=$_POST["content"];
				}
				$total=abs($_POST["total"]);
				$title_status=$_POST["title_status"];
				$sort_order=abs($_POST["sort_order"]);
				$set="location=?, widget=?, title=?, content=?, total=?, title_status=?, sort_order=?";
				$ar=array($location,$widget,$title,$content,$total,$title_status,$sort_order);
				$query=new Model();
				$insert=$query->insert_query("widgets",$set,$ar);
				if($insert){header("location:$req");}
			}
		}
	}
	public function loadWidgets()
	{
		$dir=ROOT."plugins/widgets/widgets";
		$widgets=scandir($dir);
		sort($widgets);
		foreach($widgets as $folder)
		{
			if($folder!="./" or $folder!="../")
			{
				$file=ROOT."plugins/widgets/widgets/".$folder."/add.php";
				if(file_exists($file))
				{
					include $file;
				}
			}
		}
	}
	public function tempFunc()
	{
		$template=$this->data["template"];
		require_once("../temp/".$template."/functions.php");
	}
	public function getTemplateParts()
	{
		$this->tempFunc();
		$parts=template_parts();
		$links=NULL;
		if(isset($_GET["part"]) and array_key_exists($_GET["part"],$parts))
		{
			$part=$_GET["part"];
		}else
		{
			$part=key($parts);
		}
		$this->tempPart=$part;
		foreach($parts as $file => $text)
		{
			if($file==$part){$sc="selected='selected'";}else{$sc=NULL;}
			$links.="<option value='".$file."'".$sc.">".$text."</option>";
		}	
		return $links;
	}
	public function widgetTitleOption($opt)
	{
		$opts=array("Görünmesin","Görünsün");
		$options=NULL;
		foreach($opts as $value=>$text)
		{
			if($value==$opt){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$value."' ".$sc.">".$text."</option>";
		}
		return $options;
	}
	public function categoryOption($value)
	{
		$query=new Model();
		$query->fetch_query("category","where list_on=?",array(1));
		$results=$query->results;
		$options=NULL;
		foreach($results as $row)
		{
			if($row["id"]==$value){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$row["id"]."' ".$sc.">".$row["title"]."</option>";
		}
		return $options;
	}
	public function bannerOption($value)
	{
		$query=new Model();
		$query->fetch_query("banner_group","order by title asc",NULL);
		$results=$query->results;
		$options=NULL;
		foreach($results as $row)
		{
			if($row["id"]==$value){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$row["id"]."' ".$sc.">".$row["title"]."</option>";
		}
		return $options;
	}
	
	public function serviceOption($value)
	{
		$query=new Model();
		$query->fetch_query("service","order by sort_order asc, id asc",NULL);
		$results=$query->results;
		$ex=explode(",",$value);
		$options=NULL;
		foreach($results as $row)
		{
			if(in_array($row["id"],$ex)){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$row["id"]."' ".$sc.">".$row["title"]."</option>";
		}
		return $options;
	}
	public function menuOption($value)
	{
		$query=new Model();
		$query->fetch_query("menu","order by title asc",NULL);
		$results=$query->results;
		$options=NULL;
		foreach($results as $row)
		{
			if($row["id"]==$value){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$row["id"]."' ".$sc.">".$row["title"]."</option>";
		}
		return $options;
	}
	public function listWidgets()
	{
		$this->tempFunc();
		$parts=template_parts();
		if(isset($_GET["part"]) and array_key_exists($_GET["part"],$parts))
		{
			$set="where location=? order by sort_order asc, id desc";
			$ar=array($_GET["part"]);
		}else
		{
			$set="order by sort_order asc, id desc";
			$ar=NULL;
		}
		$query=new Model();
		$query->fetch_query("widgets",$set,$ar);
		$results=$query->results;
		$query=NULL;
		$trs=NULL;
		foreach($results as $row)
		{
			$trs.="<tr>
				   	<td><input type='checkbox' name='selected[]' value='".$row["id"]."'></td>
					<td>".$row["title"]."</td>
					<td>".$this->widgetName($row["widget"])."</td>
					<td><a href='".URL."/widgets/edit&id=".$row["id"]."'>Düzenle</a></td>
				   </tr>";
		}
		return $trs;
	}
	public function widgetName($folder)
	{
		$file=ROOT."plugins/widgets/widgets/".$folder."/info.php";
		if(file_exists($file))
		{	
			include $file;
			return $widgetName;
		}else 
		{
			return "Tanımlanamadı!!!";
		}
	}
	public function totalRecords()
	{
		$this->tempFunc();
		$parts=template_parts();
		if(isset($_GET["part"]) and array_key_exists($_GET["part"],$parts))
		{
			$set="where location=? order by sort_order asc, id desc";
			$ar=array($_GET["part"]);
		}else
		{
			$set="order by sort_order asc, id desc";
			$ar=NULL;
		}
		$query=new Model();
		$tot=$query->select_total_records("widgets",$set,$ar);
		$this->totalRecords=$tot;
		$query=NULL;
	}
	public function scanWidgets()
	{
		$dir=ROOT."plugins/widgets/widgets/";
		$scan=scandir($dir,1);
		sort($scan);
		foreach ($scan as $i)
		{
			echo "<li>".$i."</li>";
		}
	}
}
?>