<div id="mediaLoaderFrame">
<div id="mediaControls" style="display:none;" data-loader="image" data-loadurl="<?php echo URL."/media/loadFrame&type=image"; ?>"></div>
	<div id="mediaFrame">
    <div id="mediaList">
    	<div id="mediaHeader">
        	<input type="text" id="mediaSearch" placeholder="Dosya adına göre ara">
            <button id="mediaSearchButton">Listele</button>
            <div id="miniUpload">
            	<iframe name="miniUploadFrame" id="miniUploadFrame" src="<?php echo URL."/media/uploadframe"; ?>"></iframe>
            	<form action="<?php echo URL."/media/uploadframe"; ?>" method="post" target="miniUploadFrame" enctype="multipart/form-data" id="miniUploadForm">
                	<div id="miniFileUpload">
                    <input type="file" name="medias[]" id="newMediaInput" multiple>
                    </div>
                    <input type="hidden" name="fileUpload">
                    <button id="miniUploadButton">Yükle</button>
                </form>
            </div>
        	<div id="mediaNav">
            	<button id="selectMedia" data-for="single_image">Tamam</button>
            	<span id="closeMedia"></span>
            </div>
        </div>
        <div id="mediaContent"></div>
    </div>
    </div>
</div>
<div id="fileUrl" data-url="<?php echo URL."/plugins/media/file.png"; ?>"></div>
<script type="text/javascript">
$(function()
{
	function selectControl(value)
	{
		var dataFor=$("#selectMedia").attr("data-for");
		if(dataFor===value)
		{
			return true;
		}else 
		{
			return false;
		}
	}
	function escapeHtml(text) 
	{
	  return text
		  .replace(/&/g, "&amp;")
		  .replace(/</g, "&lt;")
		  .replace(/>/g, "&gt;")
		  .replace(/"/g, "&quot;")
		  .replace(/'/g, "&#039;");
	}
	function loadSingleMedia()
	{
		//var loaderFor=$("#mediaControls").attr("data-loader");
		var searchText=$("#mediaSearch").val();
		var loadUrl=$("#mediaControls").attr("data-loadurl");
		if(searchText.length>0)
		{
			loadUrl=loadUrl+"&search="+searchText;
		}
		$.ajax({
			type:"GET",
			url:loadUrl,
			data:{"search":searchText},
			success: function(listmedia)
			{
				$("#mediaContent").html(listmedia);
				$(".mediaThumb").each(function(){
					var dataUrl=$(this).attr("data-url");
					$(this).css({"background-image":"url("+dataUrl+")"});
				});
				var selectedIds=$("#singleImage").val();
				if(selectedIds)
				{
					$(".mediaFrameRenderBox#"+selectedIds).addClass("selectedMedia");
				}
			}
		});
	}
	function loadMultipleMedia()
	{
		//var loaderFor=$("#mediaControls").attr("data-loader");
		var searchText=$("#mediaSearch").val();
		var loadUrl=$("#mediaControls").attr("data-loadurl");
		if(searchText.length>0)
		{
			loadUrl=loadUrl+"&search="+searchText;
		}
		$.ajax({
			type:"GET",
			url:loadUrl,
			data:{"search":searchText},
			success: function(listmedia)
			{
				$("#mediaContent").html(listmedia);
				$(".mediaThumb").each(function(){
					var dataUrl=$(this).attr("data-url");
					$(this).css({"background-image":"url("+dataUrl+")"});
				});
				var selectedIds=$("#multipleMedia").val();
				if(selectedIds.length>0)
				{
					var spl=selectedIds.split(",");
					var tot=selectedIds.length;
					for(x=0; x++; x<tot)
					{
						$(".mediaFrameRenderBox#"+spl[x]).addClass("selectedMedia");
					}	
				}
			}
		});
	}
	/// içeriğin ana resmini oluşturmak için bu kısım kullanılacak
	function selectSingleImage()
	{
		$(document).on("click",".mediaFrameRenderBox",function()
		{
			if(selectControl("single_image"))
			{
				var allClasses=$(this).attr("class");
				var spl=allClasses.split(" ");
				var tot=spl.length;
				if(tot===1)
				{
					console.log(allClasses);
					$(".mediaFrameRenderBox").removeClass("selectedMedia");
					$(this).addClass("selectedMedia");
				}else
				{
					$(this).removeClass("selectedMedia");
				}
			}
		}); 
		$(document).on("click","#mediaSearchButton",function(){
			if(selectControl("single_image"))
			{
				$("#mediaContent").html("<div class='progressBar'></div>");
				$("#mediaLoaderFrame").fadeIn();
				loadMultipleMedia();
				$("#");
			}
		});
		$(document).on("submit","#miniUploadForm",function()
		{
			if(selectControl("single_image"))
			{
				if($("#newMediaInput").val()==="" || $("#newMediaInput").val()===0)
				{
					return false;
				}else
				{
					$("#mediaContent").html("<div class='progressBar'></div>");
					$("#miniUploadFrame").load(function()
					{
						loadMultipleMedia();
						$("#newMediaInput").val("");	
					});
				}
			}
		});
		$(document).on("click","#selectMedia",function()
		{
			if(selectControl("single_image"))
			{
				var totalSelectedMedias=$(".selectedMedia").length;
				if(totalSelectedMedias!==0)
				{
					var mediaUrl=$(".selectedMedia .mediaThumb").attr("data-url");
					var mediaId=$(".selectedMedia").attr("id");
					$(".mainImage img").attr("src",mediaUrl);
					$("#singleImage").val(mediaId);
					$("#mediaLoaderFrame").fadeOut();
				}
			}
		});
		$(document).on("click","#mainImageDelete",function()
		{
			var defaultMainImage=$("#defaultMainImage").attr("data-text");
			$("#singleImage").val(0);
			$(".mainImage img").attr("src",defaultMainImage);
			return false;
		});
		$(document).on("click",".pagination a",function(event)
		{
			if(selectControl("single_image"))
			{
				var thisurl=$(this).attr("href");
				$("#mediaControls").attr("data-loadurl",thisurl);
				$("#mediaContent").html("<div class='progressBar'></div>");
				loadSingleMedia();
				return false;
			}
		});
		$(document).on("click",".mainImage",function()
		{
			$("#mediaSearch").val("");
			if(selectControl("single_image"))
			{
				$("#mediaContent").html("<div class='progressBar'></div>");
				loadSingleMedia();
				$("#mediaLoaderFrame").fadeIn();
			}
		});
	}
	selectSingleImage();
	
	function multipleImages()
	{
		$(document).on("click","#addGalleryImage",function()
		{
			if(selectControl("multiple_image"))
			{
				$("#mediaSearch").val("");
				$("#mediaContent").html("<div class='progressBar'></div>");
				$("#mediaLoaderFrame").fadeIn();
				loadMultipleMedia();
			}
		});
		$(document).on("click","#mediaSearchButton",function(){
			if(selectControl("multiple_image"))
			{
				$("#mediaContent").html("<div class='progressBar'></div>");
				$("#mediaLoaderFrame").fadeIn();
				loadMultipleMedia();
			}
		});
		$(document).on("submit","#miniUploadForm",function()
		{
			if(selectControl("multiple_image"))
			{
				if($("#newMediaInput").val()==="" || $("#newMediaInput").val()===0)
				{
					return false;
				}else
				{
					$("#mediaContent").html("<div class='progressBar'></div>");
					$("#miniUploadFrame").load(function()
					{
						loadMultipleMedia();
						$("#newMediaInput").val("");	
					});
				}
			}
		});
		$(document).on("click",".mediaFrameRenderBox",function()
		{
			if(selectControl("multiple_image"))
			{
				var allClasses=$(this).attr("class");
				var spl=allClasses.split(" ");
				var tot=spl.length;
				if(tot===2)
				{
					$(this).removeClass("selectedMedia");
				}else 
				{
					$(this).addClass("selectedMedia");
				}
			}
		});
		$(document).on("click",".pagination a",function(event)
		{
			if(selectControl("multiple_image"))
			{
				var thisurl=$(this).attr("href");
				$("#mediaControls").attr("data-loadurl",thisurl);
				$("#mediaContent").html("<div class='progressBar'></div>");
				loadMultipleMedia();
				return false;
			}
		});
		
		$(document).on("click","#selectMedia",function()
		{
			if(selectControl("multiple_image"))
			{
				var selectedMedias=[];
				$(".selectedMedia").each(function()
				{
					var id=$(this).attr("id");
					if(jQuery.inArray(id,selectedMedias)===-1)
					{
						selectedMedias.push(id);
					}
				});
				//var dataUrl=$(".selectedMedia#"+selectedMedias[0]+" .mediaThumb").attr("data-url");
				var totalImages=selectedMedias.length;
				//var galleryImages="";
				var dataUrl;
				var galleryImages="";
				for(i=0; i<totalImages; i++)
				{
					var dataMedia=$(".selectedMedia#"+selectedMedias[i]).attr("data-media");
					var dataMime=$(".selectedMedia#"+selectedMedias[i]).attr("data-media-type");
					if(dataMedia==="image" || dataMedia==="video" || dataMedia==="audio")
					{
						dataUrl=$(".selectedMedia#"+selectedMedias[i]+" .mediaThumb").attr("data-upload");
					}else
					{
						dataUrl=$("#fileUrl").attr("data-url");
					}
					var dataText="<div class='galleryImage'>";
						dataText+=loadMediaFrame(dataMedia,dataUrl,dataMime);
						dataText+="<b>Başlıksız</b>";
						dataText+="<p>İçerik yok</p>";
						dataText+="<input type='hidden' name='imageId[]' value='"+selectedMedias[i]+"'>";
						dataText+="<input type='hidden' name='imageTitle[]' class='editTitle' value='Başlıksız...'>";
						dataText+="<input type='hidden' name='imageContent[]' class='editContent' value='İçerik yok...'>";
						dataText+="<input type='hidden' name='imageOrder[]' class='editOrder' value='1'>";
						dataText+="</div>";
					$("#listImageGallery").append(dataText);
					if(galleryImages==="")
					{
						galleryImages+=selectedMedias[i];
					}else
					{
						galleryImages=galleryImages+","+selectedMedias[i];
					}
				}
				$("#mediaLoaderFrame").fadeOut();
			}
		});
	}
	function loadMediaFrame(type,text,mime)
	{
		if(type==="image")
		{
			return "<div class='imageObject' style='background-image:url("+text+")'></div>";
		}else if(type==="video")
		{
			return "<video controls class='imageObject' type='"+mime+"' src='"+text+"'></video>";
		}else if(type==="audio")
		{
			return "<audio controls class='imageObject'  type='"+mime+"' src='"+text+"'></audio>";
		}else
		{
			return "<div class='imageObject' style='background-image:url("+text+")'></div>";
		}
	}
	multipleImages();
	$(document).on("click",".galleryImage",function(){
		$(".galleryImage").removeClass("activeGal");
		$(this).addClass("activeGal");
		var editTitle=$(".activeGal .editTitle").val();
		//if(editTitle===""){editTitle="Başlıklsız..."}
		$("#editTitle").val(editTitle);
		var editOrder=$(".activeGal .editOrder").val();
		$("#editOrder").val(editOrder);
		var editContent=$(".activeGal .editContent").val();
		//if(editContent===""){editContent="İçerik yok.."}
		$("#editContentText").val(editContent);
		$("#mediaEditFrame").fadeIn();
	});
	$(document).on("click","#editOk",function(event)
	{
		var dataResult=$(".activeGal").attr("data-result");
		if(dataResult==="html")
		{
			$(".activeGal .imageObject").html(escapeHtml($("#editContentText").val()));
			$(".activeGal .editTitle").val($("#editTitle").val());
			$(".activeGal b").html($("#editTitle").val().substr(0,40)+"...");
			$(".activeGal .editContent").val($("#editContentText").val());
			$(".activeGal .editOrder").val($("#editOrder").val());
			$("#clonedHtml").removeAttr("id");
		}else 
		{
			$(".activeGal .editTitle").val($("#editTitle").val());
			$(".activeGal b").html($("#editTitle").val().substr(0,40)+"...");
			$(".activeGal .editContent").val($("#editContentText").val());
			$(".activeGal p").html($("#editContentText").val().substr(0,40)+"...");
		}
		$(".activeGal .editOrder").val($("#editOrder").val());
		$("#mediaEditFrame").fadeOut();
	});
	$(document).on("click","#closeEdit",function()
	{
		$("#mediaEditFrame").fadeOut();
	});
	$(document).on("click","#deleteObject",function()
	{
		$(".activeGal").remove();
		$("#mediaEditFrame").fadeOut();
	});
	
	
	
	function loadSettingsImages()
	{
		$(document).on("click",".mediaFrameRenderBox",function()
		{
			if(selectControl("settingImage"))
			{
				var allClasses=$(this).attr("class");
				var spl=allClasses.split(" ");
				var tot=spl.length;
				if(tot===1)
				{
					$(".mediaFrameRenderBox").removeClass("selectedMedia");
					$(this).addClass("selectedMedia");
				}else
				{
					$(this).removeClass("selectedMedia");
				}
			}
		}); 
		$(document).on("click","#mediaSearchButton",function(){
			if(selectControl("settingImage"))
			{
				$("#mediaContent").html("<div class='progressBar'></div>");
				$("#mediaLoaderFrame").fadeIn();
				loadSingleMedia();
			}
		});
		$(document).on("submit","#miniUploadForm",function()
		{
			if(selectControl("settingImage"))
			{
				if($("#newMediaInput").val()==="" || $("#newMediaInput").val()===0)
				{
					return false;
				}else
				{
					$("#mediaContent").html("<div class='progressBar'></div>");
					$("#miniUploadFrame").load(function()
					{
						loadSingleMedia();
						$("#newMediaInput").val("");	
					});
				}
			}
		});
		$(document).on("click","#selectMedia",function()
		{
			if(selectControl("settingImage"))
			{
				var totalSelectedMedias=$(".selectedMedia").length;
				if(totalSelectedMedias!==0)
				{
					var mediaUrl=$(".selectedMedia .mediaThumb").attr("data-url");
					var mediaId=$(".selectedMedia").attr("id");
					$(".focusedImage").attr("src",mediaUrl);
					var focusedParent=$(".focusedImage").parent().index();
					$(".listInputs:eq("+focusedParent+") input[type=hidden]").val(mediaUrl);
					$("#mediaLoaderFrame").fadeOut();
					return false;
				}
			}
		});
		$(document).on("click",".focusedDelete",function()
		{
			var noImage=$("#noImage").attr("data-url");
			var focusedParent=$(this).parent().parent().index();
			$(".listInputs:eq("+focusedParent+") img.singleImage").attr("src",noImage);
			$(".listInputs:eq("+focusedParent+") input[type=hidden]").val("");
			return false;
		});
		$(document).on("click",".pagination a",function(event)
		{
			if(selectControl("settingImage"))
			{
				var thisurl=$(this).attr("href");
				$("#mediaControls").attr("data-loadurl",thisurl);
				$("#mediaContent").html("<div class='progressBar'></div>");
				loadSingleMedia();
				return false;
			}
		});
		$(document).on("click",".singleImage",function()
		{
			$(".singleImage").removeClass("focusedImage");
			$(this).addClass("focusedImage");
			$("#mediaSearch").val("");
			if(selectControl("settingImage"))
			{
				$("#mediaContent").html("<div class='progressBar'></div>");
				loadSingleMedia();
				$("#mediaLoaderFrame").fadeIn();
			}
		});
	}
	loadSettingsImages();
	
});
</script>