<?php 
class Form extends Controller
{
	public function __construct()
	{
		parent::__construct();
	}	
	public function init($seflink)
	{
		$this->seflink=$seflink;
		if(method_exists($this,$seflink))
		{
			$this->$seflink();
		}
	}
	public function reservation()
	{
		if(isset($_POST["r_name"]))
		{
			$name=strip_tags($_POST["r_name"]);
			$tel=strip_tags($_POST["r_tel"]);
			$number=strip_tags($_POST["r_number"]);
			$notes=strip_tags($_POST["r_notes"]);
			$date=strip_tags($_POST["r_date"]);
			$hour=strip_tags($_POST["r_hour"]);
			$date_clear=$this->clear($date);
			$hour_clear=$this->clear($hour);
			$r_addr=$_SERVER["REMOTE_ADDR"];
			$game=strip_tags($_POST["r_game"]);
			if(strlen($name)>2 and strlen($tel)>=10 and $number>0 and $date!="" and $hour!="")
			{
				$query=new Model();
				$total=$query->select_total_records("reserve","where r_game=? and r_date_clear=? and r_hour_clear=?",array($game,$date_clear,$hour_clear));
				if($total==0)
				{
					$set="r_game=?,r_name=?, r_tel=?, r_number=?, r_notes=?, r_date=?, r_date_clear=?, r_hour=?,r_hour_clear=?, r_addr=?";
					$ar=array($game,$name,$tel,$number,$notes,$date,$date_clear,$hour,$hour_clear,$r_addr);	
					$insert=$query->insert_query("reserve",$set,$ar);
					if($insert)
					{
						$results=$this->reserveMail($game,$name,$tel,$number,$notes,$date,$hour,$r_addr);
						if($results)
						{
						echo "Ön rezervasyonunuz alınmıştır. Bilgileriniz teyid edildikten sonra işleminiz onaylanacaktır.";
						echo "<script>$(function(){\$('input,textarea').val('')})</script>";
						}else
						{
							echo "Rezervasyon kaydı alındı ama tarafımıza mail gönderilemedi. Telefonla irtibata geçmeyi 
							unutmayınız.";
							echo "<script>$(function(){\$('input,textarea').val('')})</script>";
						}
					}else
					{
						echo "Belirlenemeyen bir hata oluştu!!!";
					}
				}else
				{
					echo "Seçtiğiniz tarih ve saatte bir ön rezervasyon bulunmaktadır. Lütfen başka bir tarih veya saat seçiniz.";
				}
			}else
			{
				echo "Lütfen bilgilerinizi kontrol ediniz!!!";
			}
		}
	}
	public function reserveMail($game,$name,$tel,$number,$notes,$date,$hour,$r_addr){
		$subject="Yeni rezervasyon";
		$body="<h1>Yeni rezervasyon</h1>
			  <table>
			  	<tr>
					<td>Oyun</td>
					<td>:</td>
					<td>$game</td>
				</tr>
				<tr>
					<td>İsim soyisim</td>
					<td>:</td>
					<td>$name</td>
				</tr>
				<tr>
					<td>Telefon</td>
					<td>:</td>
					<td>$tel</td>
				</tr>
				<tr>
					<td>Kişi sayısı</td>
					<td>:</td>
					<td>$number</td>
				</tr>
				<tr>
					<td collspan='3'>Ek notlar</td>
				</tr>
				<tr>
					<td colspan='3'>$notes</td>
				</tr>
				<tr>
					<td>Rezervasyon Tarih</td>
					<td>:</td>
					<td>$date</td>
				</tr>
				<tr>
					<td>Rezervasyon Saat</td>
					<td>:</td>
					<td>$hour</td>
				</tr>
				<tr>
					<td>İp, Saat Bilgileri</td>
					<td>:</td>
					<td>$r_addr, ".date("d/m/Y")." ".date("H:i")."</td>
				</tr>
			  </table>
			  ";
		$name_surname=$name;
		$to=$this->settings["contact_email"];
		include SITE."admin/plugins/mail/class.phpmailer.php";
		include SITE."admin/plugins/mail/contact.php"; 
		if($mail->Send()){return true;}else{return false;}
	}
	public function contact_message() 
	{
		if(isset($_POST["name_surname"]))
		{
			$name_surname=strip_tags($_POST["name_surname"]);
			if(strlen($name_surname)>3)
			{
				$email=strip_tags($_POST["email"]);
				if(filter_var($email,FILTER_VALIDATE_EMAIL))
				{
					$phone=strip_tags($_POST["phone"]);
					$message=strip_tags($_POST["message"]);
					if(strlen($message)>20)
					{
						$subject="İletişim mesajı";
						$body="<h1>İletişim formu mesajı</h1>
								<table cellpadding='0' cellspacing='0' border='0'>
									<tr>
										<td><b>Ad soyad</b></td>
										<td>:</td>
										<td>$name_surname</td>
									</tr>
									<tr>
										<td><b>Telefon</b></td>
										<td>:</td>
										<td>$phone</td>
									</tr>
									<tr>
										<td><b>Email</b></td>
										<td>:</td>
										<td>$email</td>
									</tr>
									<tr>
										<td colspan='3'><b>Mesaj</b></td>
									</tr>
									<tr>
										<td colspan='3'>$message</td>
									</tr>
									<tr>
										<td><b>İp</b></td>
										<td>:</td>
										<td>".$_SERVER["REMOTE_ADDR"]."</td>
									</tr>
									<tr>
										<td><b>Tarih & Saat</b></td>
										<td>:</td>
										<td>".date("d/m/Y")." & ".date("H:i")."</td>
									</tr>
								</table>
							  ";
						  $to=$this->settings["contact_email"];
						  include SITE."admin/plugins/mail/class.phpmailer.php";
						  include SITE."admin/plugins/mail/contact.php";
						  if($mail->Send()){echo "<span style='color:green'>Mesajınız iletildi</span>";}
					}else
					{
						echo "<span style='color:red'>Mesajınız çok kısa!!!</span>";
					}
				}
			}else
			{
				return false;
			}
		}
	}
	public function franchising() 
	{
		if(isset($_POST["adsoyad"]))
		{
			$name_surname=strip_tags($_POST["adsoyad"]);
			if(strlen($name_surname)>3)
			{
				$email=strip_tags($_POST["email"]);
				if(filter_var($email,FILTER_VALIDATE_EMAIL))
				{
					$phone=strip_tags($_POST["telefon"]);
					$message=strip_tags($_POST["ek_not"]);
					$city=$_POST["il"];
					$subject="Bayilik başvurusu";
					$body="<h1>Bayilik başvuru bilgileri</h1>
							<table cellpadding='0' cellspacing='0' border='0'>
								<tr>
									<td><b>Ad soyad</b></td>
									<td>:</td>
									<td>$name_surname</td>
								</tr>
								<tr>
									<td><b>Telefon</b></td>
									<td>:</td>
									<td>$phone</td>
								</tr>
								<tr>
									<td><b>Email</b></td>
									<td>:</td>
									<td>$email</td>
								</tr>
								<tr>
									<td><b>Başvuru İli</b></td>
									<td>:</td>
									<td>$city</td>
								</tr>
								<tr>
									<td colspan='3'><b>Notlar</b></td>
								</tr>
								<tr>
									<td colspan='3' style='word-wrap:break-word;'>$message</td>
								</tr>
								<tr>
									<td><b>İp</b></td>
									<td>:</td>
									<td>".$_SERVER["REMOTE_ADDR"]."</td>
								</tr>
								<tr>
									<td><b>Tarih & Saat</b></td>
									<td>:</td>
									<td>".date("d/m/Y")." & ".date("H:i")."</td>
								</tr>
							</table>
						  ";
					  $to=$this->settings["contact_email"];
					  echo "<strong>Form detayları:</strong><br>".$body;
					  include SITE."admin/plugins/mail/class.phpmailer.php";
					  include SITE."admin/plugins/mail/contact.php";
					  if($mail->Send()){echo "<span style='color:green'>Mesajınız iletildi</span>";}
				}
			}else
			{
				return false;
			}
		}
	}
	public function meta($name)
	{
		$metas=array("title"=>$this->settings["meta_title"],
					 "description"=>$this->settings["meta_desc"],
					 "keywords"=>$this->settings["meta_keys"],
					 "author"=>$this->settings["site_name"]
					 );
		if(array_key_exists($name,$metas))
		{
			if($name="title")
			{
				if(strlen($this->settings["meta_title"])>0)
				{
					return $metas[$name];
				}else
				{
					return $metas["author"];
				}
			}else
			{
				return $metas[$name];
			}
		}else
		{
			return false;
		}
	}
}
?>