<?php 
class Post extends Controller
{
	public $row=array();
	public function __construct()
	{
		 parent::__construct();
		 
	}
	public function init($seflink)
	{
		$this->seflink=$seflink;
		if($this->total())
		{
			$this->post_details();
			$this->user_info();
			$this->category_info();
			$this->security();
			$file=SITE."system/var/post.php";
			include $file;
			$this->get("post");
		}else
		{
			$this->get("error");
		}
	}
	public function total()
	{
		$query=new Model();
		$tot=$query->select_total_records("posts","where post_seflink=? and post_status=?",array($this->seflink,1));
		$query=NULL;
		if($tot==1){return true;}else{return false;}
		
	}
	public function post_details()
	{
		$query=new Model();
		$query->select_single_query("posts","where post_seflink=? and post_status=?",array($this->seflink,1));
		$this->row=$query->results;
		$row=$query->results;
		foreach($row as $name=>$value)
		{
			$this->$name=$value;
		}
		$query=NULL;
	}
	public function user_info()
	{
		$query=new Model();
		$query->select_single_query("users","where id=?",array($this->post_author));
		$row=$query->results;
		foreach($row as $name=>$value)
		{
			$pre="user_".$name;
			$this->$pre=$value;
		}
		$query=NULL;
	}
	
	public function post_info($info)
	{
		$date=post_date($this->date_creation);
		$user_name_surname=$this->user_name." ".$this->user_surname;
		$user_username=$this->user_username;
		$author="<a href='".URL."/user/".$user_username."' title='".$user_name_surname."'>".$user_name_surname."</a>";
		if($this->comment_status==1)
		{
			$query=new Model();
			$comment_total=$query->select_total_records("comments","where post_id=?",array($this->post_id));
		}else
		{
			$comment_total=NULL;
		}
		$cate_title=$this->cate_title;
		$cate_sef=$this->cate_seflink;
		$category_info="<a href='".URL."/category/".$cate_sef."' title=".$cate_title.">".$cate_title."</a>";
		$infoarray=array("date"=>$date,
					     "category"=>$category_info,
						 "author"=>$author,
						 "comment_count"=>$comment_total
						);
		
		if(array_key_exists($info,$infoarray))
		{
			return $infoarray[$info];
		}
	}
	public function category_info()
	{
		$query=new Model();
		$tot=$query->select_total_records("category","where id=?",array($this->post_category));
		if($tot==0)
		{
			return "Bulunamadı";
		}else
		{
			$query->select_single_query("category","where id=?",array($this->post_category));
			
			foreach($query->results as $name => $value)
			{
				$pre="cate_".$name;
				$this->$pre=$value;
			}
		}
	}
	public function load_comments()
	{
		$query=new Model();
		$tot=$query->select_total_records("comments","where post_id=? and status=?",array($this->post_id,1));
		if($tot>0)
		{
			$query->fetch_query("comments","where post_id=? and status=? order by id desc ",array($this->post_id,1));
			$results=$query->results;
			$query=NULL;
			$list=NULL;
			foreach($results as $row)
			{
				$list.="<div class='comment'>
						<div class='comment_author'>".$row["name"]." : <span class='comment_date'>".comment_date($row["date"])."</span>
						</div>
						<div class='comment_details'>".strip_tags($row["comment"])."</div>
						</div>";
			}
			echo $list;
		}
	}
	public function security()
	{
		$x=0;
		$number=NULL;
		$images=NULL;
		while($x<6)
		{
			$new_a=rand(0,9);
			$number.=$new_a;
			$images.="<img src='".URL."/system/img/code_".$new_a.".png' alt='".$new_a."'>";
			$x++;
		}
		$this->security=$number;
		$this->security_images=$images;
	}
	public function new_comment()
	{
		if(isset($_POST["comment"]))
		{
			$name=strip_tags($_POST["name"]);
			$email=strip_tags($_POST["email"]);
			$comment=strip_tags($_POST["comment"]);
			if(filter_var($email,FILTER_VALIDATE_EMAIL))
			{
				if(strlen($name)>2)
				{
					$ip=$_SERVER["REMOTE_ADDR"];
					$date=date("d M Y")." ; ".date("H:i");
					$time=time();
					$ar=array($this->post_id,$email,$name,$comment,0,$date,$time);
					$set="post_id=?, email=?, name=?, comment=?, status=?, date=?, time=?";
					$query=new Model();
					$result=$query->insert_query("comments",$set,$ar);
					if($result)
					{
						echo "Yorumunuz eklendi. Kontrolden geçtikten sonra görüntülenecektir.";
						$to=$this->settings["contact_email"];
						$subject=$this->settings["site_name"]." sitenizden yeni yorum gönderildi";
						$body="<h1>Yeni yorum gönderildi</h1><br>
							   <b>İsim :</b> $name<br>
							   <b>Email :</b> $email<br>
							   <b>Yorum :</b><br>
							   $comment<br>
							   <b>Tarih :</b> $date<br>
							   <b>İp :</b> $ip;
							  ";
						include SITE."admin/plugins/mail/class.phpmailer.php";
						include SITE."admin/plugins/mail/comment.php";
					}
				}else
				{
					echo "İsminiz çok kısa!!!";
				}
			}else
			{
				echo "Geçersiz eposta adresi";
			}
		}
	}
	public function meta($name)
	{
		if($this->total())
		{
		$metas=array("title"=>$this->meta_title,
					 "real_title"=>$this->post_title,
					 "description"=>$this->meta_desc,
					 "keywords"=>$this->meta_tags,
					 "author"=>$this->user_username
					 );
		if(array_key_exists($name,$metas))
		{
			if($name="title")
			{
				if(strlen($this->meta_title)>0)
				{
					return $metas[$name];
				}else
				{
					return $metas["real_title"];
				}
			}else
			{
				return $metas[$name];
			}
		}else
		{
			return false;
		}
		}else
		{
			$metas=array("title"=>$this->settings["meta_title"],
						 "description"=>$this->settings["meta_desc"],
						 "keywords"=>$this->settings["meta_keys"],
						 "author"=>$this->settings["site_name"]
					 	);
			if(array_key_exists($name,$metas))
			{
				if($name="title")
				{
					if(strlen($this->settings["meta_title"])>0)
					{
						return $metas[$name];
					}else
					{
						return $metas["author"];
					}
				}else
				{
					return $metas[$name];
				}
			}else
			{
				return false;
			}
		}
	}
	public function post_medias()
	{
		$query=new Model();
		$tot=$query->select_total_records("gallery","where content_id=?",array($this->post_id));
		if($tot==0)
		{
			return false;
		}else
		{
			$query->fetch_query("gallery","where content_id=? order by sort_order asc, id asc",array($this->post_id));
			$results=$query->results;
			$query->results=array();
			$media_list=NULL;
			foreach($results as $row)
			{
				$media_id=$row["media_id"];
				$content_media_types=array("photo","video","audio","other");
				if(in_array($this->content_type,$content_media_types))
				{
					$query->select_single_query("media","where id=?",array($media_id));
					$media_row=$query->results;
					$query->results=array();
					$media_print=$this->media_print($media_row["url"],$media_row["type"],$media_row["mime_type"],$media_row["title"]);
				}else
				{
					$media_print=NULL;
				}
				if($this->content_list_type=="blog")
				{
					$media_list.="<div class='post_media_list'>
										<h2>".$row["foto_title"]."</h2>
										<div class='post_media_print'>".$media_print."</div>
										<div class='post_media_content'>".$row["foto_content"]."</div>
								  </div>
								 ";
				}else
				{
					$media_list.="<div class='media_post_thumb'>".$media_print."</div>";
				}
			}
			return $media_list;
		}
	}
	public function media_print($url,$type,$mime,$title)
	{
		$media_template="temp/".$this->template."/media_temp.php";
		include($media_template);
		return $return;
	}
}
?>