<?php 
/*
Functions alanındaki fonsiyonları kullanarak temanızda ihtiyaç olan ya da olabilecek çeşitli yapılar oluşturabilirsiniz.
Bu dosya silindiğinde sistem hata verecektir.
Aynı şekilde eğer temanızın herhangi bir kısmında bu dosyada olmayan bir fonksiyon kullanılırsa hata ile karşılaşma ihtimaliniz yüksektir.
bu dosya bileşenler(widgets) oluşturmak için açık kaynak şeklinde verilmektedir.
Olası bir düzeltmeyi buradan yapabilirsiniz.
Daha fazla kaynak bilgiye www.iyonsi.com/yardim bloğundan ulaşabilirsiniz.
*/
// slider & afiş bölgesi
function slider($id)
{	
	global $widget;
	$query=new Model();
	$tot=$query->select_total_records("banner","where b_group=?",array($id));
	if($tot>0)
	{
		$query->fetch_query("banner","where b_group=? order by sort_order asc, id desc",array($id));
		$results=$query->results;
		$query=NULL;
		$banners=NULL;
		foreach($results as $row)
		{
			if($row["image"]>0)
			{
				$bg=image_url($row["image"]);
				if(strlen($row["link"])>1)
				{
					$link="<div class='banner_link'>
						   <a class='banner_link_button' href='".$row["link"]."'>".$row["link_text"]."</a>
						   </div>";
				}else
				{
					$link=NULL;
				}
				if(($row["title"]==NULL or $row["title"]=="") and ($row["content"]==NULL or $row["content"]==""))
				{
					 $content=NULL;
				}else
				{
				$content="<div class='banner_text'>
								<div class='banner_title'>".$row["title"]."</div>
								<div class='banner_content'>".$row["content"]."</div>
								".$link."
							</div>";
				}
				$banners.="<div class='banner' style='background-image:url(".$bg.")'>".$content."</div>";
			}
		}
		return $banners;
	}	
}
//slider & afiş bitimi
/// kategori bölgesi
$all_categories=array();
function check_below_id($id)
{
	global $all_categories;
	$query=new Model();
	$tot=$query->select_total_records("category","where parent_id=?",array($id));
	
	$query->select_single_query("category","where id=?",array($id));
	$row=$query->results;
	if(!in_array($row["id"],$all_categories))
	{
		array_push($all_categories,$row["id"]);
	}
	if($tot>0)
	{
		$query->fetch_query("category","where parent_id=?",array($id));
		$results=$query->results;
		$query=NULL;
		if(!in_array($row["id"],$all_categories))
		{
			array_push($all_categories,$row["id"]);
		}
		foreach($results as $row)
		{
			check_below_id($row["id"]);
		}
	}else 
	{
		$query=NULL;
	}
}
function category_array($id)
{
	check_below_id($id);
	global $all_categories;
	return $all_categories;
}
function list_category()
{
	$query=new Model();
	$tot=$query->select_total_records("category","where list_on=? and parent_id=?",array(1,0));
	if($tot==0)
	{
		$query=NULL;
		return false;
	}else
	{
		$query->fetch_query("category","where list_on=? and parent_id=?",array(1,0));
		$results=$query->results;
		$query=NULL;
		echo "<ul class='category_list_widget'>";
		foreach ($results as $row)
		{
			categoryLoop($row["id"]);
		}
		echo "</ul>";
	}
}
function categoryLoop($id)
{
	$query=new Model();
	$tot=$query->select_total_records("category","where parent_id=? and list_on=?",array($id,1));
	
	$query->select_single_query("category","where id=?",array($id));
	$row=$query->results;
	$link=URL."/category/".$row["seflink"];
	echo "<li id='cat_item_".$row["id"]."'><a href='".$link."' title='".$row["title"]."'>".$row["title"]."</a>";
	if($tot>0)
	{
		$query->fetch_query("category","where parent_id=? and list_on=?",array($id,1));
		$results=$query->results;
		$query=NULL;
		echo "<ul>";
		foreach($results as $row)
		{
			categoryLoop($row["id"]);
		}
		echo "</ul>";
	}else 
	{
		$query=NULL;
	}
	echo "</li>";
}
//kategori bitişi
//yorum bölgesi
function last_comments($total)
{
	$query=new Model();
	$tot=$query->select_total_records("comments","where status=?",array(1));
	if($tot>0)
	{
		if($total==0)
		{
			$limit="limit 0 , 5";
		}else
		{
			$limit="limit 0 , ".$total;
		}
		$query->fetch_query("comments","where status=? order by id desc ".$limit,array(1));
		$results=$query->results;
		$query=NULL;
		$list=NULL;
		foreach($results as $row)
		{
			$list.="<div class='comment'>
					<div class='comment_author'>".$row["name"]." : <span class='comment_date'>".comment_date($row["date"])."</span>
					</div>
					<div class='comment_details'>".mb_substr(strip_tags($row["comment"]),0,100)." ...</div>
					</div>";
		}
		return $list;
	}
}
function trDate($text)
{
	$en=array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Sept','Oct','Nov','Dec');
	$tr=array('Ocak','Şubat','Mart','Nisan','Mayıs','Haziran','Temmuz','Ağustos','Eylül','Eylül','Ekim','Kasım','Aralık');
	$newText=str_replace($en,$tr,$text);
	return $newText;
}
function comment_date($date)
{
	$ex=explode(";",$date);
	return trDate($ex[0]." ".$ex[1]);
}
// yorum bitişi
// media bölgesi
function image_url($id)
{
	$query=new Model();
	$tot=$query->select_total_records("media","where id=?",array($id));
	if($tot==1)
	{
		$query->select_single_query("media","where id=?",array($id));
		$row=$query->results;
		$query=NULL;
		return URL."/admin/uploads/".$row["url"];
	}else
	{
		$query=NULL;
		return false;
	}
}
function media_url($id)
{
	$query=new Model();
	$tot=$query->select_total_records("media","where id=?",array($id));
	if($tot==1)
	{
		$query->select_single_query("media","where id=?",array($id));
		$row=$query->results;
		$query=NULL;
		return URL."/admin/uploads/".$row["url"];
	}else
	{
		$query=NULL;
		return URL."/admin/plugins/media/image.png";
	}
}
function media_title($id)
{
	$query=new Model();
	$tot=$query->select_total_records("media","where id=?",array($id));
	if($tot==1)
	{
		$query->select_single_query("media","where id=?",array($id));
		$row=$query->results;
		$query=NULL;
		return $row["title"];
	}else
	{
		$query=NULL;
		return false;
	}
}
/// media bitişi
// menü bölgesi
function get_menu($id)
{	
	$query=new Model();
	$query->fetch_query("menutab","where menu_id=? and tab_parent=? order by sort_order asc, id asc",array($id,0));
	$results=$query->results;
	$query=NULL;
	echo "<ul>";
	foreach($results as $row){menu_item($row["id"]);}
	echo "</ul>";
}
function menu_item($item)
{
	global $start;
	$query=new Model();
	$tot=$query->select_total_records("menutab","where tab_parent=?",array($item));
	if($tot==0)
	{
		$query->select_single_query("menutab","where id=?",array($item));
		$row=$query->results;
		$query=NULL;
		$link=menu_link($row["tab_type"],$row["tab_content"]);
		echo "<li id='li_item_".$row["id"]."'><a href='".$link."' title='".$row["tab_title"]."'>".$row["tab_title"]."</a></li>";
	}else
	{
		$query->select_single_query("menutab","where id=?",array($item));
		$row=$query->results;
		$link=menu_link($row["tab_type"],$row["tab_content"]);
		echo "<li id='li_item_".$row["id"]."'><a href='".$link."' title='".$row["tab_title"]."'>".$row["tab_title"]."</a>";
		echo "<ul id='ul_item_".$row["id"]."'>";
		$query->fetch_query("menutab","where tab_parent=? order by sort_order asc, id asc",array($item));
		$results=$query->results;
		$query=NULL;
		foreach($results as $row){menu_item($row["id"]);}  
		echo "</ul></li>";
	}
}
function menu_link($type,$content)
{
	switch($type)
	{
	case "link": $link=$content; break;
	case "post": $link=type_post($content); break;
	case "category": $link=type_category($content); break;
	case "page": $link=type_page($content); break;
	default:$link="#error"; break;
	}
	return $link;
}

function type_post($content)
{
	$query=new Model();
	$tot=$query->select_total_records("posts","where post_id=?",array($content));
	if($tot>0)
	{
		$query->select_single_query("posts","where post_id=?",array($content));
		$row=$query->results;
		$seflink=$row["post_seflink"];
		return URL."/post/".$seflink;
	}else
	{
		return "#";
	}
}
function type_category($content)
{
	$query=new Model();
	$tot=$query->select_total_records("category","where id=?",array($content));
	if($tot>0)
	{
		$query->select_single_query("category","where id=?",array($content));
		$row=$query->results;
		$seflink=$row["seflink"];
		return URL."/category/".$seflink;
	}else
	{
		return "#";
	}
}
function type_page($content)
{
	$query=new Model();
	$tot=$query->select_total_records("page","where id=?",array($content));
	if($tot>0)
	{
		$query->select_single_query("page","where id=?",array($content));
		$row=$query->results;
		$seflink=$row["seflink"];
		return URL."/page/".$seflink;
	}else
	{
		return "#";
	}
}
//menü bitişi
// sayga bölgesi
$all_pages=array();
$page_labels=NULL;
function page_array($id)
{
	global $all_pages,$page_labels;
	$query=new Model();
	$tot=$query->select_total_records("page","where parent_id=?",array($id));
	if($tot==0 and $id!=0)
	{
		if($id!=0)
		{
			if(!in_array($id,$all_pages))
			{
				array_push($all_pages,$id);
			}
		}
	}else
	{
		if($id!=0)
		{
			if(!in_array($id,$all_pages))
			{
				array_push($all_pages,$id);
			}
		}
		$query->fetch_query("page","where parent_id=? order by sort_order asc, id asc",array($id));
		$results=$query->results;
		$query=NULL;
		foreach($results as $row)
		{
			if(!in_array($row["id"],$all_pages))
			{
				array_push($all_pages,$row["id"]);
			}
		}
	}
}
function list_pages()
{
	$query=new Model();
	$tot=$query->select_total_records("page","where parent_id=?",array(0));
	if($tot>0)
	{
		$query->fetch_query("page","where parent_id=? order by sort_order asc, id asc",array(0));
		$results=$query->results;
		$query=NULL;
		echo "<ul class='page_list_widget'>";
		foreach ($results as $row)
		{
			pageLoop($row["id"]);
		}
		echo "</ul>";
	}else
	{
		return false;
	}
}
function pageLoop($id)
{
	$query=new Model();
	$tot=$query->select_total_records("page","where parent_id=?",array($id));
	if($tot==0)
	{
		$query->select_single_query("page","where id=?",array($id));
		$row=$query->results;
		$query=NULL;
		$link=URL."/page/".$row["seflink"];
		echo "<li id='page_item_".$row["id"]."'><a href='".$link."' title='".$row["title"]."'>".$row["title"]."</a></li>";
	}else
	{
		$query->select_single_query("page","where id=?",array($id));
		$row=$query->results;
		$link=URL."/page/".$row["seflink"];
		echo "<li id='page_item_".$row["id"]."'><a href='".$link."' title='".$row["title"]."'>".$row["title"]."</a><ul>";
			  $query->fetch_query("page","where parent_id=? order by sort_order asc, id asc",array($id));
			  $results=$query->results;
			  $query=NULL;
			  foreach($results as $row)
			  {
				pageLoop($row["id"]); 
			  }
		echo "</ul></li>";
	}
}
//sayfa bitişi
// içerik bölgesi
function post_array($total)
{
	global $all_categories;
	$query=new Model();
	$set=NULL;
	$array=array();
	foreach($all_categories as $i)
	{
		if($set==NULL)
		{
			$set.="where post_category = ? ";
			array_push($array,$i);
		}else
		{
			$set.=" or post_category=? ";
			array_push($array,$i);
		}
	}
	if($total==0)
	{
		$limit="order by post_id desc limit 0 , 5";
	}else
	{
		$limit="order by post_id desc limit 0 , ".$total;
	}
	
	$query->fetch_query("posts",$set.$limit,$array);
	$results=$query->results;
	$query=NULL;
	$post_array=array();
	foreach ($results as $row)
	{
		array_push($post_array,$row["post_id"]);
	}
	return $post_array;
}
function list_posts($total,$category_id)
{
	
	check_below_id($category_id);
	$posts=post_array($total);
	$list=NULL;
	foreach($posts as $id)
	{
		$query=new Model();
		$tot=$query->select_total_records("posts","where post_id=? and post_status=?",array($id,1));
		if($tot==1)
		{
			$query->select_single_query("posts","where post_id=? and post_status=?",array($id,1));
			$row=$query->results;
			$query=NULL;
			$title=mb_substr($row["post_title"],0,50)."...";
			$content=mb_substr(strip_tags($row["post_content"]),0,150)."...";
			$image=image_url($row["post_image"]);
			if($image==false)
			{
				$post_image=NULL;	
				$post_class="post_summary_noimage";
			}else
			{
				$image_title=media_title($row["post_image"]);
				$post_image="<div class='post_image' style='background-image:url(".$image.")'></div>";
				$post_class="post_summary";
			}
			$post_date=post_date($row["date_creation"]);
			$link=URL."/post/".$row["post_seflink"];
			//<div class='post_content'>".$content."</div><div class='post_date'>".$post_date."</div>
			$list.="<div class='".$post_class."'>
						<a href='".$link."'>
						".$post_image."
						</a>
						<a href='".$link."'>
						<div class='post_title'>".$title."</div>
						</a>
						<div class='post_link'><a href='$link'>Devamı...</a></div>
						
					</div>";
		}
	}
	return $list;
}
function single_post($id)
{
		$query=new Model();
		$tot=$query->select_total_records("posts","where post_id=? and post_status=?",array($id,1));
		if($tot==1)
		{
			$query->select_single_query("posts","where post_id=? and post_status=?",array($id,1));
			$row=$query->results;
			$query=NULL;
			$title=mb_substr($row["post_title"],0,50)."...";
			$content=mb_substr(strip_tags($row["post_content"]),0,100)."...";
			$image=image_url($row["post_image"]);
			if($image!=false)
			{
				$post_class="post_summary";
				$image_title=media_title($row["post_image"]);
				$image_object="<div class='post_image'><img src='".$image."' alt='".$image_title."'></div>";
			}else
			{
				$post_class="post_summary_noimage";
				$image_object=NULL;
			}
			$post_date=post_date($row["date_creation"]);
			$link=URL."/post/".$row["post_seflink"];
			return "<div class='".$post_class."'>
						<a href='".$link."'>
						".$image_object."
						<div class='post_title'>".$title."</div>
						<div class='post_date'>".$post_date."</div>
						</a>
					</div>";
		}
}
function post_date($date)
{
	$ex=explode(";",$date);
	return trDate($ex[0]." ".$ex[1]);
}
function last_posts($total)
{
	$query=new Model();
	$tot=$query->select_total_records("posts",NULL,NULL);
	if($tot>0)
	{
		if($total==0)
		{
			$limit="limit 0 , 5";
		}else
		{
			$limit="limit 0 , ".$total;
		}
		$query->fetch_query("posts","where post_status=? order by post_id desc ".$limit,array(1));
		$results=$query->results;
		$query=NULL;
		$list=NULL;
		foreach($results as $row)
		{
			$list.=single_post($row["post_id"]);
		}
		if($list!=NULL)
		{
			return $list;
		}else
		{
			return false;
		}
	}
}
function post_($name)
{
	global $class;
	$row=$class->row;
	return $row[$name];
}
// içeriik bitişi
// servis bölgesi
function list_services($content)
{
	$ex=explode(",",$content);
	$set=NULL;
	$ar=array();
	foreach($ex as $id)
	{
		$id=trim($id);
		if($set==NULL)
		{
			$set.="where id=?";
		}else
		{
			$set.="or id=?";
		}
		array_push($ar,$id);
	}
		$order=" order by sort_order asc";
		$query=new Model();
		$tot=$query->select_total_records("service",$set.$order,$ar);
		if($tot>0)
		{
			$query->fetch_query("service",$set.$order,$ar);
			$results=$query->results;
			$query=NULL;
			$list=NULL;
			foreach($results as $row)
			{
				$image_url=image_url($row["image"]);
				if($row["link"]=="#")
				{
					$button=NULL;
				}else
				{
					$button="<div class='service_button'>
								<a href='".$row["link"]."' title='".$row["link_text"]."'>".$row["link_text"]."</a>
							</div>	
							";
				}
				$list.="<div class='service'>	
							<div class='service_image'>
								<img src='".$image_url."' title='".$row["title"]."' alt='".$row["title"]."'>
							</div>
							<div class='service_text'>
								<div class='service_title'>".$row["title"]."</div>
								<div class='service_content'>".strip_tags($row["content"])."</div>
								".$button."
							</div>
						</div>";
			}
			return $list;
		}
}
// servisi bitişi
// ayar bölgesi
function logo_url()
{
	global $start;
	if($start->settings["site_logo"])
	{
		return $start->settings["site_logo"];
	}else
	{
		return false;
	}
}
function social_links($image=NULL)
{
	global $start;
	$settings=array( "site_facebook",
					 "site_twitter",
					 "site_google_plus",
					 "site_youtube",
					 "site_instagram",
					 "site_linkedin",
					 "site_vimeo",
					 "site_dailymotion",
					 "site_soundcloud"
					 );
	$links=NULL;
	if($image=="text")
	{	
		$text=array( "site_facebook"=>"facebook",
					 "site_twitter"=>"twitter",
					 "site_google_plus"=>"google+",
					 "site_youtube"=>"youtube",
					 "site_instagram"=>"instagram",
					 "site_linkedin"=>"linkedin",
					 "site_vimeo"=>"vimeo",
					 "site_dailymotion"=>"dailymotion",
					 "site_soundcloud"=>"soundcloud"
					 );
		foreach ($settings as $link)
		{
			$value=$start->settings[$link];
			if($value!="" or $value!=NULL)
			{
				$links.="<a href='".$value."' target='_blank'>".$text[$link]."</a>";
			}
		}
	}else
	{
		foreach ($settings as $link)
		{
			$value=$start->settings[$link];
			if($value!="" or $value!=NULL)
			{
				$img=$start->temp_url."/img/".$link.".png";
				$links.="<a href='".$value."' target='_blank'><img src='".$img."'></a>";
			}
		}
	}
	return $links;
}
function faxes($i)
{
	global $start;
	$faxes=$start->settings["fax_numbers"];
	if(strlen($faxes)>0)
	{
		$ex=explode(",",$faxes);
		if(array_key_exists($i,$ex))
		{
			return $ex[$i];
		}
	}
}
function phones($i)
{
	global $start;
	$phones=$start->settings["phone_numbers"];
	if(strlen($phones)>0)
	{
		$ex=explode(",",$phones);
		if(array_key_exists($i,$ex))
		{
			return $ex[$i];
		}
	}
}
function mobiles($i)
{
	global $start;
	$phones=$start->settings["mobilephone_numbers"];
	if(strlen($phones)>0)
	{
		$ex=explode(",",$phones);
		if(array_key_exists($i,$ex))
		{
			return $ex[$i];
		}
	}
}
function emails($i)
{
	global $start;
	$emails=$start->settings["emails"];
	if(strlen($emails)>0)
	{
		$ex=explode(",",$emails);
		if(array_key_exists($i,$ex))
		{
			return $ex[$i];
		}
	}
}
function bg_image()
{
	global $start;
	$bg=$start->settings["site_bg_image"];
	if(strlen($bg)>0)
	{
		return "style='background-image:url(".$bg.")'";
	}
}
function favicon()
{
	global $start;
	$icon=$start->settings["site_favicon"];
	if(strlen($icon)>0)
	{
		return "<link href='".$icon."' rel='shortcut icon'>";
	}
}
function site_name()
{
	global $start;
	return $start->settings["site_name"];
}
// ayar bitişi
//bileşen bölgesi
function widget_status($part)
{
	$query=new Model();
	$total=$query->select_total_records("widgets","where location=?",array($part));
	$query=NULL;
	if($total==0){return false;}elseif($total>0){return true;}else{return false;}
}
function get_widgets($location)
{
	global $start,$all_categories;
	$query=new Model();
	$query->fetch_query("widgets","where location=? order by sort_order asc, title asc",array($location));
	$results=$query->results;
	$query=NULL;
	foreach ($results as $widget)
	{
		$file=SITE."temp/".$start->template."/widgets/".$widget["widget"].".php";
		if(file_exists($file))
		{
			include $file;
		}
	}
}
//bileşen bitişi
// oyun bölgesi
function getGames($total)
{
	$query=new Model();
	$query->fetch_query("games","order by sort_order asc, id asc",NULL);
	$results=$query->results;
	$games=NULL;
	foreach ($results as $row)
	{
		$link=URL."/games/".$row["seflink"];
		$image=image_url($row["image"]);
		$games.="<div class='game_box'>
					<a href='".$link."'>
					<div class='game_name'>".$row["name"]."</div>
					<div class='game_image' style='background-image:url(".$image.")'></div>
					</a>
					<div class='game_link'><a href='".$link."'>Detaylı İncele</a></div>
				 </div>";
	}
	return $games;
}
function getGameNames($total)
{
	$query=new Model();
	$query->fetch_query("games","order by sort_order asc, id asc limit 0,".$total,NULL);
	$results=$query->results;
	$games=NULL;
	foreach ($results as $row)
	{
		$link=URL."/games/".$row["seflink"];
		$games.="<a href='".$link."' title='".$row["name"]."'>".$row["name"]."</a>";
	}
	return $games;
}
//oyun bitişi
?>